#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 58 "c-parse.y"
/* $Id: c-parse.y,v 1.38 2013/10/26 01:05:12 phargrov Exp $ */

#include "config.h"
#include "system.h"
#include <setjmp.h>

#include "tree.h"
#include "input.h"
#include "c-lex.h"
#include "c-tree.h"
#include "flags.h"
#include "output.h"
#include "toplev.h"
#include "ggc.h"

#ifdef MULTIBYTE_CHARS
#include <locale.h>
#endif

#include <upc-act.h>


/* Since parsers are distinct for each language, put the language string
   definition here.  */
const char * const language_string = "GNU UPC";

 extern void WFE_Pop_Pragma();  /*from wfe_dst.cxx*/
 extern void WFE_Push_Pragma();  /*from wfe_dst.cxx*/
 extern void WFE_Start_Inner_Scope();
 extern void WFE_Finish_Inner_Scope();
 
 extern int defining_type; 

/* Like YYERROR but do call yyerror.  */
#define YYERROR1 { yyerror ("syntax error"); YYERROR; }

/* Cause the `yydebug' variable to be defined.  */
/* #define YYDEBUG 1  -- Set via HOSTDEFS in Makefile.gbase, and then only for DEBUG builds */
#line 100 "c-parse.y"
typedef union {long itype; tree ttype; enum tree_code code;
	const char *filename; int lineno; int ends_in_label; } YYSTYPE;
#line 234 "c-parse.y"
/* Number of statements (loosely speaking) and compound statements 
   seen so far.  */
static int stmt_count;
static int compstmt_count;
  
/* Input file and line number of the end of the body of last simple_if;
   used by the stmt-rule immediately after simple_if returns.  */
static char *if_stmt_file;
static int if_stmt_line;

/* List of types and structure classes of the current declaration.  */
/*static*/ tree current_declspecs = NULL_TREE;
static tree prefix_attributes = NULL_TREE;

/* Stack of saved values of current_declspecs and prefix_attributes.  */
static tree declspec_stack;

/* 1 if we explained undeclared var errors.  */
/*static*/ int undeclared_variable_notice;

/* A phony value of for_init_stmt identifying a for loop w/ c99 declaration.
   Anything that can't be a valid statement is suitable.  */
#define c99_for_node integer_type_node


/* Tell yyparse how to print a token's value, if yydebug is set.  */

#define YYPRINT(FILE,YYCHAR,YYLVAL) yyprint(FILE,YYCHAR,YYLVAL)
extern void yyprint			PARAMS ((FILE *, int, YYSTYPE));

/* Add GC roots for variables local to this file.  */
void
c_parse_init ()
{
  ggc_add_tree_root (&declspec_stack, 1);
  ggc_add_tree_root (&current_declspecs, 1);
  ggc_add_tree_root (&prefix_attributes, 1);
}
#line 98 "c-parse.c"
#define YYERRCODE 256
#define IDENTIFIER 257
#define TYPENAME 258
#define SCSPEC 259
#define TYPESPEC 260
#define TYPE_QUAL 261
#define TYPE_QUAL_S 262
#define CONSTANT 263
#define STRING 264
#define ELLIPSIS 265
#define SIZEOF 266
#define ENUM 267
#define STRUCT 268
#define UNION 269
#define IF 270
#define ELSE 271
#define WHILE 272
#define DO 273
#define FOR 274
#define SWITCH 275
#define CASE 276
#define DEFAULT 277
#define BREAK 278
#define CONTINUE 279
#define RETURN 280
#define GOTO 281
#define ASM_KEYWORD 282
#define TYPEOF 283
#define ALIGNOF 284
#define ATTRIBUTE 285
#define EXTENSION 286
#define LABEL 287
#define REALPART 288
#define IMAGPART 289
#define ASSIGN 290
#define OROR 291
#define ANDAND 292
#define EQCOMPARE 293
#define ARITHCOMPARE 294
#define LSHIFT 295
#define RSHIFT 296
#define UNARY 297
#define PLUSPLUS 298
#define MINUSMINUS 299
#define HYPERUNARY 300
#define POINTSAT 301
#define INTERFACE 302
#define IMPLEMENTATION 303
#define END 304
#define SELECTOR 305
#define DEFS 306
#define ENCODE 307
#define CLASSNAME 308
#define PUBLIC 309
#define PRIVATE 310
#define PROTECTED 311
#define PROTOCOL 312
#define OBJECTNAME 313
#define CLASS 314
#define ALIAS 315
#define OBJC_STRING 316
#define FORALL 317
#define UPC_BLOCKSIZEOF 318
#define UPC_LOCALSIZEOF 319
#define UPC_ELEMSIZEOF 320
#define UPC_BARRIER 321
#define UPC_NOTIFY 322
#define UPC_WAIT 323
#define END_OF_LINE 324
#define UPC_FENCE 325
#define BUPC_ASSERT_TYPE 326
const short yylhs[] = {                                        -1,
    0,    0,   85,   83,   86,   83,   84,   84,   84,   84,
   88,   88,   88,   88,   88,   88,   88,   88,   91,   93,
   87,   87,   94,   95,   87,   87,   96,   97,   87,   87,
    2,    2,    1,    1,    1,    1,    1,    1,    1,    3,
    5,    5,    4,    4,    8,    8,    8,    8,    8,    8,
    8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
    8,   79,   80,   81,   82,   98,   99,    7,    7,  101,
    7,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,  102,    6,  103,    6,  104,  105,
    6,  106,    6,    6,    6,    9,    9,    9,    9,    9,
  107,    9,    9,    9,    9,    9,    9,    9,    9,    9,
    9,    9,   10,   10,   90,   90,   90,  109,  108,  108,
  108,  108,  110,  110,  110,  110,   70,  112,  113,  113,
  113,  113,  113,  113,  113,   11,   11,   12,   12,   12,
   12,   18,   18,   19,   19,   19,   15,   15,   15,   15,
   20,   20,   20,   20,   58,   58,   58,   13,   13,   78,
   14,   14,   16,   16,   16,   16,   16,   17,   17,   17,
   17,   17,   23,   23,   24,   24,   28,   28,  116,   25,
   25,  117,   26,   26,   33,   33,   34,   34,   35,   36,
   36,   37,   37,   37,   37,   37,   38,   38,   38,   38,
   38,   27,  118,   27,   27,  100,  100,  119,  119,  121,
  121,  125,  121,  121,  126,  123,  123,  123,  122,  122,
  124,  124,  124,  127,  128,  114,  129,  130,  115,   40,
   40,   42,   42,   42,   42,   42,   42,   42,  131,  131,
  131,  131,  132,  132,   43,   43,   43,   43,   43,   43,
   43,   41,   41,   41,   41,   41,   41,   41,   41,   52,
   52,   53,   53,   54,   54,  133,   44,   44,   44,  134,
   44,   44,   44,  135,   44,  137,   44,   44,  120,  120,
  136,  136,   45,   45,   46,   46,   46,   47,   47,   47,
   47,   47,   47,   48,   48,   49,   49,   49,   50,   50,
   50,   51,   51,   55,   55,   56,   56,   21,   21,   59,
   59,   57,   57,   57,   57,   57,   57,   57,   57,   57,
   57,  138,   73,   73,   73,  111,  139,  140,  140,  141,
  141,  142,   92,   92,  143,   39,   39,   39,  144,  144,
  145,  148,  147,   75,   76,  146,  146,   72,   74,   74,
   74,  149,  149,  149,  152,  149,  149,  149,  153,  154,
  149,  149,  149,  155,  156,  157,  149,  158,  159,  160,
  161,  149,  162,  149,  149,  149,  149,  149,  149,  149,
  149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
  149,  149,  163,   71,   71,   77,   77,  151,  165,  164,
  150,  150,  150,  150,   22,   22,   60,   60,   60,   29,
   29,   30,   30,   31,   32,   32,  166,   64,   65,  167,
   65,   65,   66,   66,   66,   66,   61,   61,   62,   62,
   62,   62,   62,  168,   67,   68,   68,   63,   63,   69,
   69,   89,
};
const short yylen[] = {                                         2,
    0,    1,    0,    2,    0,    3,    1,    1,    5,    2,
    3,    4,    4,    2,    2,    2,    2,    1,    0,    0,
    7,    4,    0,    0,    7,    4,    0,    0,    6,    3,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    0,    1,    1,    3,    1,    2,    2,    2,    2,    2,
    4,    2,    4,    2,    4,    2,    4,    2,    4,    2,
    2,    1,    1,    1,    1,    1,    1,    1,    4,    0,
    7,    1,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    0,    4,    0,    4,    0,    0,
    7,    0,    5,    3,    3,    1,    1,    1,    3,    3,
    0,    4,    6,    6,    6,    6,    4,    4,    3,    3,
    2,    2,    1,    2,    0,    1,    2,    3,    1,    1,
    2,    2,    4,    4,    2,    2,    0,    0,    4,    4,
    3,    3,    2,    2,    2,    2,    3,    0,    2,    2,
    2,    2,    3,    0,    2,    2,    1,    1,    2,    2,
    1,    1,    2,    2,    1,    1,    2,    2,    3,    3,
    0,    2,    1,    1,    1,    4,    4,    1,    1,    1,
    2,    1,    1,    3,    1,    3,    0,    4,    0,    6,
    3,    0,    6,    3,    0,    1,    1,    2,    6,    1,
    3,    0,    1,    4,    6,    4,    1,    1,    1,    1,
    1,    1,    0,    4,    1,    0,    2,    1,    3,    3,
    2,    0,    4,    1,    0,    4,    1,    1,    1,    2,
    2,    5,    3,    0,    0,    5,    0,    0,    5,    1,
    1,    3,    3,    4,    3,    3,    3,    1,    0,    2,
    2,    1,    1,    2,    3,    5,    5,    4,    3,    3,
    1,    3,    3,    3,    5,    5,    4,    3,    1,    1,
    2,    1,    2,    1,    2,    0,    7,    5,    2,    0,
    7,    5,    2,    0,    8,    0,    7,    2,    0,    1,
    0,    1,    1,    2,    0,    3,    2,    3,    1,    3,
    1,    1,    2,    1,    3,    4,    6,    5,    1,    3,
    1,    1,    3,    2,    2,    0,    1,    1,    2,    0,
    2,    3,    3,    2,    3,    5,    4,    2,    4,    3,
    3,    1,    1,    2,    2,    2,    0,    0,    1,    1,
    2,    3,    1,    2,    1,    2,    5,    5,    2,    2,
    4,    0,    4,    0,    0,    3,    4,    3,    1,    1,
    1,    1,    1,    2,    0,    4,    1,    3,    0,    0,
    7,    5,    2,    0,    0,    0,   11,    0,    0,    0,
    0,   14,    0,    6,    2,    2,    2,    3,    2,    2,
    3,    2,    3,    2,    3,    6,    8,   10,   12,    3,
    4,    1,    0,    2,    2,    1,    1,    1,    0,    6,
    3,    5,    2,    3,    0,    1,    0,    1,    1,    0,
    1,    1,    3,    4,    1,    3,    0,    2,    2,    0,
    4,    2,    0,    1,    1,    3,    1,    3,    4,    4,
    4,    4,    4,    0,    2,    1,    2,    1,    3,    1,
    3,    1,
};
const short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,  165,  152,  163,  155,    0,
    0,    0,    0,    0,    0,    0,  442,   18,    0,    0,
  138,    0,    0,  187,  164,    0,    0,    0,  151,    0,
    4,    7,    8,    0,    6,   16,   17,    0,  157,    0,
    0,    0,    0,    0,    0,   15,    0,   14,  138,    0,
    0,    0,    0,  154,  153,  188,   31,   32,  285,    0,
  285,    0,  276,    0,  259,  310,    0,    0,  175,    0,
    0,   10,   96,   97,  113,   66,   67,    0,    0,    0,
   33,   35,   34,    0,   36,   37,    0,   62,   63,   64,
   65,   38,   39,    0,  408,    0,    0,   72,   68,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  161,    0,    0,  308,    0,  238,  310,
    0,    0,  173,    0,    0,    0,    0,    0,    0,    0,
  140,  168,  169,    0,  139,    0,  172,    0,    0,  266,
    0,  270,    0,  274,    0,    0,   11,    0,    0,   30,
    0,  434,    0,    0,    0,   60,   61,   49,   46,    0,
    0,    0,    0,   48,    0,    0,    0,    0,   87,   85,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  111,  112,    0,    0,    0,    0,  114,  160,
    0,   52,    0,   54,    0,   56,    0,   47,    0,   50,
    0,   58,    0,  166,  310,    0,    0,    0,  304,    0,
    0,  161,  305,  309,  167,  198,  199,  200,  201,  197,
    0,  190,    0,    0,    0,   13,    0,    0,   22,    0,
    0,  434,    0,   12,   26,    0,  171,    0,  292,  287,
    0,    0,    0,    0,  285,    0,  285,  301,    0,    0,
  299,    0,    0,  311,  253,  176,    0,    0,    0,  252,
    0,    0,  243,    0,    0,    0,    0,    0,  345,   28,
    0,    0,  120,  100,   99,    0,  335,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   75,   76,   77,  110,  109,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    9,    0,    0,  318,    0,    0,    0,  417,    0,
  162,    0,    0,    0,    0,    0,  232,  174,    0,    0,
   20,  233,  235,    0,   24,  268,  344,  344,  286,  293,
    0,  272,    0,    0,    0,    0,    0,    0,    0,  438,
  424,  127,    0,    0,  427,    0,  436,    0,  435,    0,
    0,  257,    0,  241,  244,  182,  326,    0,    0,  117,
  121,  122,   70,   69,  102,  336,    0,    0,    0,    0,
    0,  107,  108,   53,   55,   57,    0,    0,   51,   59,
    0,  312,  418,  320,    0,    0,  315,    0,  189,  191,
    0,    0,  179,    0,  234,    0,    0,  294,  345,    0,
    0,    0,    0,  300,    0,    0,  178,  422,    0,    0,
  420,    0,  437,    0,  419,  255,  256,    0,  144,    0,
    0,  118,    0,  333,   29,    0,    0,    0,    0,  330,
   90,    0,    0,    0,    0,    0,  319,  317,    0,  194,
    0,  196,    0,   21,   25,  344,    0,  267,  271,  277,
    0,  251,  310,    0,    0,    0,    0,    0,  310,    0,
    0,    0,    0,  426,  428,  439,  205,  203,    0,  183,
    0,  125,    0,  126,  144,    0,  334,  218,    0,    0,
    0,  215,    0,    0,    0,    0,  208,    0,  214,    0,
  440,    0,    0,  323,    0,  345,    0,  331,    0,  106,
  105,  104,  103,  316,    0,  180,  295,    0,    0,  275,
    0,    0,  430,  434,    0,  429,  431,    0,    0,  432,
  433,  421,    0,  146,  145,    0,    0,    0,    0,  221,
    0,    0,  212,   71,    0,  207,    0,  220,  211,  332,
    0,  337,  324,  325,    0,  338,    0,  195,    0,    0,
  296,    0,    0,  245,    0,    0,  123,  124,    0,  223,
    0,    0,  209,  210,  441,    0,    0,  359,  342,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  392,    0,    0,    0,    0,  352,  348,
    0,  351,    0,    0,    0,  349,  350,  353,  398,  298,
    0,    0,  248,    0,  204,    0,  216,  213,    0,    0,
  344,    0,    0,    0,  403,  375,  376,  377,    0,    0,
    0,  406,    0,    0,  384,    0,  379,    0,  382,    0,
  380,    0,  354,  133,    0,  134,    0,  135,    0,  340,
  345,  339,  363,    0,  297,  246,  247,  222,    0,    0,
    0,    0,    0,  364,  344,    0,    0,  401,  378,    0,
  390,    0,  368,  385,  381,  383,  404,    0,    0,  131,
    0,    0,  132,  358,  344,    0,    0,  341,    0,  343,
  399,  394,    0,  395,  373,    0,  391,    0,    0,  129,
    0,  130,    0,  356,  346,  344,    0,  360,  344,    0,
  344,  402,    0,    0,    0,  225,  228,  347,  362,  344,
  400,  365,  374,    0,    0,    0,  412,  386,  369,    0,
    0,  361,    0,    0,    0,    0,    0,    0,  226,  229,
    0,    0,    0,  387,  413,    0,  366,  414,    0,    0,
  370,  344,    0,    0,  388,    0,  367,    0,    0,  397,
  396,    0,  389,    0,  371,  344,  372,
};
const short yydgoto[] = {                                       1,
   94,  493,   95,   96,  302,   97,   98,   99,  100,  101,
  352,   53,  113,  211,  353,  114,  135,  430,  481,   22,
  115,  633,  122,   68,  123,   69,  480,  154,  725,  726,
  727,  754,  266,  267,   24,  221,  222,  223,  434,  257,
  126,  127,  467,   25,  138,  139,  243,  407,  408,  250,
  251,   26,   27,   28,  116,  209,  210,   29,  145,  663,
  354,  355,  356,  315,  357,  358,  260,  359,  502,   30,
  664,  504,  505,  600,  651,  368,  762,   39,  103,  104,
  105,  106,    2,   31,    3,    4,   32,   33,  107,  270,
  231,  435,  404,  236,  406,  155,  369,  108,  109,  495,
  436,  286,  285,  283,  509,  284,  163,  271,  272,  432,
  273,  149,  602,  680,  683,  453,  428,  533,  496,  546,
  497,  498,  499,  500,  572,  542,  701,  730,  703,  731,
  264,  265,  245,  247,  252,  346,  143,  507,  377,  438,
  439,  440,  279,  603,  604,  652,  605,  621,  606,  607,
  608,  685,  620,  720,  693,  733,  752,  699,  738,  756,
  766,  711,  665,  609,  709,  316,  473,  261,
};
const short yysindex[] = {                                      0,
    0,    0, 5119, 5119,   88,    0,    0,    0,    0,   -9,
 -193, -193, -193,   71,   77,  124,    0,    0,   66,  883,
    0,  553, -193,    0,    0,  -68,  -61,  198,    0,   79,
    0,    0,    0, 5119,    0,    0,    0, 3391,    0, -193,
 -193, -193, 3430, 1955,  160,    0,  318,    0,    0,  553,
 -193,   79, 1020,    0,    0,    0,    0,    0,    0,  117,
    0,  177,    0,  191,    0,    0,   79,  176,    0, -193,
  179,    0,    0,    0,    0,    0,    0, 3430, 3430,   11,
    0,    0,    0, 3430,    0,    0, 1885,    0,    0,    0,
    0,    0,    0, 3430,    0,  183, 4366,    0,    0,    7,
  -14,  211, 3494, 3533, 3597,  314, 3430, 3662, 3701, 3430,
  284,  337,   89,    0,  559,  365,    0,  637,    0,    0,
  318,  595,    0, -193,  -78,  148,  241, 1020,  694,  186,
    0,    0,    0,   -9,    0, -193,    0,  293, 1593,    0,
  300,    0,  859,    0,  375,  367,    0,  318,   79,    0,
  391,    0,  218, -193,  227,    0,    0,    0,    0,  406,
  430,  464,  392,    0, 3430, 3430, 3430,    0,    0,    0,
 3430, 3430, 3430, 3430, 3430, 3430, 3430, 3430, 3430, 3430,
 3430, 3430,    0,    0,   11,   11, 3430, 3430,    0,    0,
 1885,    0, 1885,    0, 1885,    0, 1999,    0, 1885,    0,
 1885,    0,  488,    0,    0,   89,  218, -193,    0,  310,
 1052,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  220,    0,  519,   54,  543,    0,  318,  318,    0, -193,
  227,    0, 2319,    0,    0,  227,    0, -193,    0,    0,
    0, 2294,  506, 1767,    0, -193,    0,    0,  532,  551,
    0,  859,  148,    0,    0,    0,  332,  148,  374,    0,
 2198,  366,    0, 2384,  240,  585, -193,  609,    0,    0,
  410,  227,    0,    0,    0, 2449,    0,  635,  573, 4366,
 4366, 4366, 3430,  649, 3430, 3430,  755, 1116,  654,  156,
   85,  995,  995,  893,  893,    0,    0,    0,    0,    0,
  183,  670,  628,  684,  691,  713, 2488,  699,  711,  722,
  724,    0,  250,  611,    0, 3067, 2553,   89,    0,  218,
    0, 1052,  731,  637, 3765,  241,    0,    0,  241,  735,
    0,    0,    0,  701,    0,    0,    0,    0,    0,    0,
  679,    0,  709, 3430,   11,  718,  551,   10,  784,    0,
    0,    0, 3233,  698,    0,  700,    0,  800,    0,  591,
 2624,    0,  768,    0,    0,    0,    0, 1492,  -62,    0,
    0,    0,    0,    0,    0,    0,  596,  815, 3430,  586,
  200,    0,    0,    0,    0,    0, 1999, 1999,    0,    0,
  310,    0,    0,    0,  794,  310,    0, 2689,    0,    0,
  741,  836,    0,  -62,    0,  -62,  856,    0,    0,  856,
 -193, -193, 4366,    0, -193,  785,    0,    0,  716,   45,
    0, 2068,    0,  659,    0,    0,    0, 2187,    0,  873,
 1041,    0,  392,    0,    0, 2084,   11,  685,  596,    0,
    0, 1289,  904,  911,  918,  920,    0,    0,  861,    0,
 3430,    0, 2187,    0,    0,    0,  215,    0,    0,    0,
 -193,    0,    0,   45, -193,    2,  127, -193,    0, -193,
    2, -193, 3067,    0,    0,    0,    0,    0, 4366,    0,
 1167,    0,  318,    0,    0,   79,    0,    0,    0,   11,
 3430,    0,  917, 4366,  844,  940,    0,  185,    0, 2261,
    0,  702,  864,    0,  227,    0,  882,    0, 3430,    0,
    0,    0,    0,    0,  847,    0,    0, 3430,  -18,    0,
  175,  716,    0,    0,  218,    0,    0,  526,   45,    0,
    0,    0, 2084,    0,    0,  707, 1167,  757,   49,    0,
 4159, 2084,    0,    0, 2084,    0, 2261,    0,    0,    0,
   11,    0,    0,    0, 1349,    0, 1289,    0, 4193, 3430,
    0,  394,  394,    0, 2756,  901,    0,    0, 3430,    0,
  906, 2261,    0,    0,    0,    0, 1005,    0,    0, 1012,
 1025, 3430, 1010, 1019, 1044, 2815,  181,  823, 1064, 2858,
 2923, 2991, 1050,    0, 1055, 1059, 1061, 1419,    0,    0,
 1450,    0,  851,  871,   39,    0,    0,    0,    0,    0,
 4193, 3055,    0, 1035,    0, 4239,    0,    0, 3430, 1089,
    0, 3391, 3430, 4171,    0,    0,    0,    0, 1078, 3430,
 1087,    0, 1107, 3391,    0, 1090,    0, 1096,    0, 1097,
    0, -193,    0,    0,  318,    0,   79,    0,  892,    0,
    0,    0,    0, 3430,    0,    0,    0,    0, 1119, 3430,
  890,   19, 1105,    0,    0, 1124, 3430,    0,    0, 1108,
    0, 3430,    0,    0,    0,    0,    0,  759,  332,    0,
  791,   49,    0,    0,    0, 1617, 1137,    0, 1143,    0,
    0,    0, 3391,    0,    0, 4322,    0,   47, 3391,    0,
  227,    0,  227,    0,    0,    0, 1147,    0,    0, 1149,
    0,    0,  945, 1151, 1154,    0,    0,    0,    0,    0,
    0,    0,    0, 1175,  327, 1172,    0,    0,    0,  392,
  392,    0, 3391, 3430,  945, 1161,  945, 3391,    0,    0,
 1184, 1186,  616,    0,    0, 1169,    0,    0,  374, 1170,
    0,    0,  -14,  916,    0, 3120,    0, 1178,  374,    0,
    0, 1200,    0,  -14,    0,    0,    0,
};
const short yyrindex[] = {                                    607,
    0,  987,   76,   76,    0,    0,    0,    0,    0, 4552,
  385,  407,  457,    0,    0,    0,    0,    0,  363,   76,
    0, 4680, 3644,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   76,    0,    0,    0, 1157,    0,  462,
  533,  590,    0,    0,    0,    0,    0,    0,    0, 4724,
 4957,    0, 1224,    0,    0,    0,    0,    0,    0, 4628,
    0, 4649,    0, 4693,    0,    0,    0,    0,    0,  108,
 3607,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  328,    0,    0, 1128,    0,    0,    0,
    0,    0,    0,    0,    0,  600,  764,    0,    0, 4101,
 4029,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  942,    0,  942,    0,    0,  944,    0,    0,
    0,    0,    0,  313, 4927, 4974, 4993, 1940,    0, 5056,
    0,    0,    0, 4000,    0, 5204,    0,    0, 1117,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 3159,  623, 1432,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 3223,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1212,    0,    0,    0,
 1128,    0, 1128,    0, 1128,    0,    0,    0, 1128,    0,
 1128,    0,    0,    0,    0, 1331, 3159,  447,    0,   82,
 2280,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  989,    0,    0,    0,    0,    0,    0,  623,
 1432,    0,    0,    0,    0, 1432,    0, 5102,    0,    0,
   41,  552, 1132,    0,    0, 5102,    0,    0,   40, 1135,
    0,    0, 4744,    0,    0,    0,   53, 4797,    0,    0,
 1220,    0,    0,    0, 3262,  801,  645,    0,    0,    0,
 1835,  571,    0,    0,    0,    0,    0,    0,  736, 1159,
 1827, 2806,    0,    0,    0,    0, 2935, 4589, 4581, 4541,
 4504, 2337, 3954, 4453, 4465,    0,    0,    0,    0,    0,
 1221,    0,    0,    0,    0,    0, 1128,    0,    0,    0,
    0,    0, 1003,    0,    0, 1220,    0,    0,    0, 3159,
    0, 2499,    0,  944, 1212, 4871,    0,    0, 4915,  826,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1138,    0, 1135,    0,    0,    0,
    0,    0, 1066,  800,    0,    0,    0,    0,    0, 3327,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  913,    0,    0, 2630,
 3551,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  143,    0,    0,    0,    0,  269,    0,    0,    0,    0,
 3892,    0,    0,    0,    0,    0,  194,    0,    0,  238,
 5102, 5102,   99,    0, 5102,    0,    0,    0,  404,  404,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  363,
  172,    0,    0,    0,    0, 1142,    0, 1520, 1081,    0,
    0, 2121,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 5102,    0,    0, 1331,  733,  668,  668,  668,    0,  491,
  668,  668, 1220,    0,    0,    0,    0,    0,  827,    0,
  482,    0,    0,    0,    0,    0,    0,    0, 4056,    0,
    0,    0,    0,  138,    0, 1146,    0,    0,    0,  460,
    0,    0,    0,    0, 1181,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  166,    0,
  693,    0,    0,    0, 3159,    0,    0,  693,    0,    0,
    0,    0, 1142,    0,    0,    0, 1001,    0,   53,    0,
    0, 1142,    0,    0, 1150,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2375,    0,  166,    0,
    0,  475,  499,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2869,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1234,    0,    0,
    0,    0,    0,    0,    0,    0,  363,   76,    0,    0,
    0,    0,  813, 1687,    0,    0,    0,    0,    0,    0,
  166,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1163,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1163,    0,    0,    0,    0,    0,    0,
    0, 1252,    0,    0,    0,    0,    0,    0, 1788,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  686,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 5024,    0,
    0, 5043,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1217,    0,    0,    0,    0,    0, 1217,    0,
 1432,    0, 1432,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  621,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  664,    0,    0,    0,    0,
    0,    0, 1236,    0,  621,    0,    0, 1217,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1022,    0,    0, 1236,    0,    0,    0,    0,
    0,    0,    0, 1023,    0,    0,    0,
};
const short yygindex[] = {                                      0,
    0,  -23,  -42, -155,  953,  217,   -4,  -36,  662, -245,
   12, 1242,  -76, 1084,   14,   18, -188,    0,  808,   -7,
  -73,    0, -450,  -45,  -92,    0,  845, -101,  581,    0,
  580,    0,   -2,   24,  135,    0,  994,    0, -144,  -41,
   34,  -43,    4,  -19,    9,    0, 1085,  984,  869, 1076,
  985,    0,    0,    0,   87,  -72, -102,  285,  -90,  -38,
    0,  924,    0, 1014, -267,    0, -201,    0,    0,   -8,
  734,  830,    0,    0, -129, -285,    0, 1237,    0,    0,
    0,    0,    0,  104,    0,    0,    0,    0,    5, -211,
    0,  133,    0,    0,    0,    0,    0,    0,    0,   93,
    0,    0,    0,    0,    0,    0,    0,    0, -261,    0,
 -222,  -95,  773,    0,    0,    0,    0,    0,    0,    0,
  831,    0, -340,  886,    0,    0,    0,    0,    0,    0,
 -166, 1123,    0,    0,    0, 1034,    0,    0,    0,    0,
    0,  947,    0,    0,    0, 1479,    0,    0,  704,  710,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 5473
const short yytable[] = {                                     102,
  111,  112,   60,   62,   64,  125,  129,   34,   34,  371,
   47,   52,   50,  348,   19,   19,   20,   20,  278,  331,
   21,   21,  321,  230,  335,  269,   23,   23,  228,  224,
  332,  301,  536,  137,   40,   41,   42,   49,   34,  560,
  317,  152,  213,   51,  161,   19,  187,   20,  393,  372,
  417,   21,  186,   70,   59,  256,  158,   23,  187,  691,
  277,   61,  241,   71,  186,  242,  192,  194,  196,  141,
  124,  200,  202,  156,  157,   70,  136,  225,  654,  159,
  127,   38,  127,  302,  464,  130,  469,  714,  152,  164,
   70,   16,  153,  121,  220,  120,  177,  188,  127,  289,
  146,  269,  198,  314,  713,  159,  269,   35,  137,  188,
   43,  177,  318,  177,  313,  127,   44,  127,   67,  249,
   66,  182,  307,  457,   46,  307,  180,  178,  206,  179,
  205,  181,  212,  321,  328,  207,  208,   72,  208,  153,
  307,  269,  303,  244,  124,  303,   36,  128,  161,  128,
  161,  136,  161,  398,  146,  230,  161,   56,  161,  549,
  308,  299,  300,   45,  302,  289,  524,  241,   70,  301,
  242,  124,   70,  162,   56,   56,   56,  229,  253,  207,
  326,  217,  258,  313,  329,   56,  313,  152,   57,   58,
  334,  137,  182,  433,  678,   57,   58,  180,  178,  118,
  179,  313,  181,  151,   56,  532,  574,  409,  409,  185,
  391,  127,   37,  127,  464,  396,  463,  525,  152,  148,
  555,  363,  630,  303,  185,  152,  165,  330,  249,  208,
  490,  618,  337,  338,  147,  336,  182,  173,  153,  140,
  378,  180,  178,  342,  179,  547,  181,  124,  244,  189,
  124,  124,  288,  341,  121,  343,  120,  253,   56,  212,
  323,  258,  217,  324,  161,  207,   16,   57,   58,  153,
   56,  374,  518,  189,  395,  491,  153,  304,   21,  305,
  232,  306,  554,  309,   23,  310,   16,  311,  487,  206,
  185,  205,  535,  172,  653,  515,  290,  127,  127,  142,
  220,   65,  137,  190,  183,  184,   55,  185,  506,  321,
   65,  119,  321,  144,    9,   10,  183,  184,  288,  185,
   63,  249,  564,  171,  203,  127,  409,  321,  117,   16,
  151,  233,  127,   21,   55,   65,  208,  177,   16,   23,
  207,  208,   56,  419,  420,   50,  468,  472,  535,  319,
  443,  445,  128,  197,  128,  449,  159,  121,  565,  120,
  431,  314,  290,   16,  128,  686,  307,  736,  409,  522,
   49,  117,  521,   16,  529,  506,   51,  204,  528,  176,
  177,  280,  281,  282,  735,  429,  409,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,  298,  214,
  320,   56,  127,  694,  127,  215,  152,  255,  458,  459,
  599,   16,  460,  501,   67,  519,   66,  238,  391,  396,
  409,  483,  486,  117,  246,  391,  396,  313,  127,  254,
  259,   65,  462,  524,  150,    9,   10,   57,   58,   21,
  538,  235,  465,  470,  306,   23,  274,  306,  485,  175,
  176,  177,  466,  471,   57,   58,  127,  153,  520,   16,
  151,  137,  306,  523,  526,  527,  540,  151,  530,  531,
  275,   65,  119,  444,  446,  117,  262,  117,  263,  117,
  124,  117,  268,  117,  525,  117,  128,  470,  128,  716,
   21,  717,  174,  175,  176,  177,   23,  146,  364,   16,
  365,  380,  381,  753,  276,  219,  124,  264,  254,   70,
    9,   10,  596,  764,  277,  249,  561,  137,  249,  539,
  219,  142,  614,  142,  562,  563,  214,  575,  117,  260,
  128,  595,  128,  249,   16,  269,  454,  128,  455,  250,
  142,  599,  250,  629,  465,  465,  312,  636,  638,  640,
  219,  470,  470,  321,  253,  258,  610,  250,  325,  601,
  413,  253,  258,  631,  339,  464,  597,  469,  598,  128,
  128,  269,   21,  269,   65,  119,  659,  230,   23,  262,
  666,  128,  232,  327,  265,  739,  740,  670,  645,  647,
   50,  127,  344,  127,  345,  442,  198,  254,  206,   56,
  205,  681,   16,  679,   56,  601,    1,  159,  655,  127,
  291,  687,  597,  151,  598,   49,  207,  689,   21,  127,
  127,   51,  182,  173,   23,  566,  263,  180,  178,  698,
  179,   65,  181,  233,  571,    9,   10,   75,  227,  677,
   40,  264,  264,  596,  479,  366,    3,  127,    3,  207,
  319,  392,  494,  226,  710,  261,  750,   40,   40,   16,
  715,  410,  595,  260,  260,    3,  185,  367,  124,  479,
   70,  117,  117,  749,  370,  375,  291,  186,  410,  172,
  682,  185,  186,  185,  186,  186,  186,  186,  186,  186,
  182,  742,   40,  119,  741,  180,  178,  376,  179,  746,
  181,  320,  186,  186,  411,  186,  379,  541,  185,  171,
  382,  185,  263,  262,  262,   55,  494,  761,  265,  265,
  383,  411,   45,   45,  384,  557,  185,   45,   45,   45,
   45,  385,   45,  314,  559,  186,  314,  148,  142,  142,
  423,  422,  387,  424,   45,  551,   45,  128,   45,  494,
  227,  314,  234,  386,  388,  464,  421,  463,  494,  249,
  550,  494,  389,  494,  390,  567,  142,  186,  327,  186,
  186,  399,  128,  327,  128,  327,  611,  327,  327,   45,
  327,  450,   65,  250,  451,  616,    9,   10,  494,  261,
  261,  182,  173,  405,  327,  403,  180,  178,  624,  179,
  148,  181,  227,  411,   43,  254,  207,   43,  127,   45,
   16,   54,  254,    9,   10,  568,    6,  700,    8,    9,
   10,   43,   43,  128,  418,   11,   12,   13,  119,  119,
  119,  119,  119,  412,  148,  119,  127,  119,  119,  119,
  425,   15,  415,   16,  184,  357,  263,  263,  172,  702,
  357,  365,  357,  119,  357,  357,   43,  357,  327,  184,
  427,  327,    3,    3,    3,    3,    3,    3,    3,  181,
  202,  357,  441,    3,    3,    3,  452,  170,  174,  175,
  176,  177,  437,  696,  181,  202,  447,  558,    3,    3,
  165,    3,    3,   57,   58,  216,  217,  218,  219,  456,
  186,  186,  186,  186,  186,  186,  186,  186,  186,  461,
  186,  186,  186,  186,  186,  476,  186,  186,  186,  186,
  186,  186,  186,  186,  186,  186,  186,  186,  186,  182,
  186,  482,  186,  186,  180,  357,  186,  357,  357,  181,
  503,   48,  186,  186,  510,  328,  174,  175,  176,  177,
  328,  511,  328,  514,  328,  328,  758,  328,  512,  759,
  513,  186,  186,  186,  186,  186,  186,  186,  544,  186,
  186,  328,   65,  462,  543,   45,   45,   45,   45,   45,
   45,   45,  306,  545,  192,  306,    2,  192,  552,  128,
  128,  327,  327,  327,  327,  327,  327,  327,  327,  327,
   16,  327,  327,  327,  327,  327,  556,  327,  327,  327,
  327,  327,  327,  327,  327,  327,  327,  327,  327,  327,
  327,  327,  327,  327,  327,  615,    5,  327,    5,  193,
  617,  182,  193,  327,  327,  328,  180,  178,  328,  179,
  143,  181,  143,  314,  619,    5,  314,  174,  175,  176,
  177,  622,  327,  327,  327,  327,  327,  327,  327,  143,
  327,  327,  415,  416,  623,  415,  416,  625,  357,  357,
  357,  357,  357,  357,  357,  357,  357,  626,  357,  357,
  357,  357,  357,  632,  357,  357,  357,  357,  357,  357,
  357,  357,  357,  357,  357,  357,  357,  357,  357,  484,
  357,  357,  627,  634,  357,  127,  127,  127,  641,  127,
  357,  357,  642,  329,  248,   57,   58,  643,  329,  644,
  329,  649,  329,  329,  127,  329,  650,  657,  660,  357,
  357,  357,  357,  357,  357,  357,  669,  357,  357,  329,
    6,    7,    8,    9,   10,  671,  672,  684,  674,   11,
   12,   13,  182,  173,  675,  676,  127,  180,  178,  688,
  179,  690,  181,  692,  695,   15,  697,   16,  328,  328,
  328,  328,  328,  328,  328,  328,  328,  707,  328,  328,
  328,  328,  328,  708,  328,  328,  328,  328,  328,  328,
  328,  328,  328,  328,  328,  328,  328,  328,  328,   44,
  328,  328,   44,  329,  328,  719,  329,  722,  724,  728,
  328,  328,  729,  344,  734,  737,   44,   44,  344,  744,
  344,  407,  344,  344,  747,  344,  748,  751,  755,  328,
  328,  328,  328,  328,  328,  328,  763,  328,  328,  344,
  765,  283,    5,    5,    5,    5,    5,    5,    5,  407,
  101,   44,   41,    5,    5,    5,  284,  143,  143,  281,
  423,   42,  282,  136,  136,  136,  206,  136,    5,    5,
  279,    5,    5,  405,  280,  407,  407,  402,  131,  132,
  133,  134,  136,  662,  185,  143,   11,   12,   13,  185,
  128,  185,  537,  185,  185,  322,  185,  516,    6,   54,
    8,    9,   10,  344,   16,  322,  344,   11,   12,   13,
  185,  132,  133,  134,  136,  743,  745,  400,   11,   12,
   13,  410,  127,   15,  517,  182,  173,  347,  340,  414,
  180,  178,  397,  179,  553,  181,  329,  329,  329,  329,
  329,  329,  329,  329,  329,  475,  329,  329,  329,  329,
  329,  168,  329,  329,  329,  329,  329,  329,  329,  329,
  329,  329,  329,  329,  329,  329,  329,  673,  329,  329,
  237,  417,  329,  648,  185,  573,  185,  185,  329,  329,
  416,   93,  172,  548,  360,  508,   81,    0,   87,  705,
  110,   82,    0,   83,    0,  706,    0,  329,  329,  329,
  329,  329,  329,  329,    0,  329,  329,  594,  174,  175,
  176,  177,  171,    0,    0,    0,    0,    0,    0,    0,
  393,  393,  393,  393,  393,  534,  132,  133,  134,  393,
  393,  393,    0,   11,   12,   13,    0,  344,  344,  344,
  344,  344,  344,  344,  344,  393,  344,  344,  344,  344,
  344,    0,  344,  344,  344,  344,  344,  344,  344,  344,
  344,  344,  344,  344,  344,  344,  344,    0,  344,  344,
    0,  277,  344,    0,   92,    0,    0,  646,  344,  344,
  136,  136,   93,    0,    0,    0,    0,   81,    0,   87,
    0,  110,   82,    0,   83,    0,    0,  344,  344,  344,
  344,  344,  344,  344,    0,  344,  344,  185,  185,  185,
  185,  185,  185,  185,  185,  185,    0,  185,  185,  185,
  185,  185,    0,  185,  185,  185,  185,  185,  185,  185,
  185,  185,  185,  185,  185,  185,    0,  185,    0,  185,
  185,    0,    0,  185,    0,    0,    0,    0,    0,  185,
  185,    0,  344,    0,  115,    0,    0,  344,    0,  344,
    0,  344,  344,    0,  344,    0,    0,    0,  185,  185,
  185,  185,  185,  185,  185,   92,  185,  185,  344,  169,
  170,  174,  175,  176,  177,    0,  417,    0,  417,  417,
  417,  417,  417,    0,    0,  417,    0,  417,  417,  417,
    0,    0,    0,    0,    0,  489,  576,    7,    8,    9,
   10,   74,   75,  417,   76,   11,   12,   13,  577,    0,
  578,  579,  580,  581,  582,  583,  584,  585,  586,  587,
  588,   15,   77,   16,   17,    0,   78,   79,    0,    0,
   80,    0,  344,    0,    0,  344,   85,   86,    0,   93,
    0,  240,    0,    0,   81,    0,   87,    0,  110,   82,
    0,   83,    0,    0,    0,  589,   88,   89,   90,  590,
  591,  592,    0,  593,   91,  594,    6,    7,    8,    9,
   10,    0,    0,    0,    0,   11,   12,   13,    0,  344,
  344,  344,  344,  344,    0,    0,    0,    0,  344,  344,
  344,   15,    0,   16,    0,    0,   73,    6,    7,    8,
    9,   10,   74,   75,  344,   76,   11,   12,   13,  344,
    0,    0,    0,    0,  344,    0,  344,    0,  344,  344,
    0,  344,   15,   77,   16,   17,    0,   78,   79,  277,
    0,   80,   92,    0,    0,  344,    0,   85,   86,    6,
    7,    8,    9,   10,    0,    0,    0,    0,   11,   12,
   13,    0,    0,    0,    0,    0,    0,   88,   89,   90,
    0,    0,    0,    0,   15,   91,  344,  344,  344,  344,
  344,  344,  344,  344,    0,  344,  344,  344,  344,  344,
    0,  344,  344,  344,  344,  344,  344,  344,  344,  344,
  344,  344,  344,  344,  344,  344,    0,  344,  344,  344,
    0,  344,  344,    0,    0,    0,    0,  344,  344,    0,
  355,    0,    0,    0,    0,  355,    0,  355,    0,  355,
  355,    0,  355,    0,    0,    0,  344,  344,  344,  344,
  344,  344,  344,    0,  344,  344,  355,    0,  239,    0,
    6,    0,    8,    9,   10,    0,    0,    0,    0,   11,
   12,   13,    0,    0,    0,    0,    0,   95,    0,    0,
   95,    0,    0,  489,   58,   15,    0,    0,   17,   74,
   75,    0,   76,    0,   95,   95,  577,    0,  578,  579,
  580,  581,  582,  583,  584,  585,  586,  587,  588,    0,
   77,    0,   17,    0,   78,   79,    0,    0,   80,    0,
  355,    0,    0,  355,   85,   86,    0,   93,    0,   95,
    0,    0,   81,    0,   87,    0,  110,   82,    0,   83,
    0,    0,    0,  589,   88,   89,   90,  590,  591,  592,
    0,  593,   91,  344,  344,    0,    0,    0,    0,  344,
  344,   95,  344,    0,    0,    0,  344,  116,  344,  344,
  344,  344,  344,  344,  344,  344,  344,  344,  344,    0,
  344,    0,  344,    0,  344,  344,    0,    0,  344,  137,
  137,  137,    0,  137,  344,  344,    0,   93,    0,    0,
    0,    0,   81,    0,   87,    0,  110,   82,  137,   83,
    0,    0,    0,  344,  344,  344,  344,  344,  344,  344,
   92,  344,  344,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  239,    0,    6,    0,    8,    9,   10,    0,
  137,   93,    0,   11,   12,   13,   81,    0,  307,    0,
  110,   82,    0,   83,  355,  355,    0,    0,    0,   15,
  355,  355,   17,  355,    0,    0,    0,  355,    0,  355,
  355,  355,  355,  355,  355,  355,  355,  355,  355,  355,
    0,  355,    0,  355,    0,  355,  355,    0,    0,  355,
   92,    0,    0,    0,    0,  355,  355,    0,    0,    0,
  116,   95,  344,  344,  344,  344,  344,    0,    0,  661,
    0,  344,  344,  344,  355,  355,  355,  355,  355,  355,
  355,   95,  355,  355,    0,    0,   93,  344,    0,    0,
    0,   81,    0,   87,   92,  110,   82,    0,   83,  490,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  160,   73,    6,    0,    8,    9,   10,   74,   75,    0,
   76,   11,   12,   13,    0,    0,    0,    0,    0,    0,
    0,   93,    0,  704,   93,    0,    0,   15,   77,    0,
   17,    0,   78,   79,  491,    0,   80,    0,   93,   93,
    0,   93,   85,   86,  718,    0,    0,  721,    0,  723,
    0,    0,    0,    0,    0,    0,  137,  137,  732,    0,
    0,    0,   88,   89,   90,    0,  492,    0,    0,   92,
   91,   73,    6,   93,    8,    9,   10,   74,   75,   93,
   76,   11,   12,   13,   81,    0,   87,    0,  110,   82,
  757,   83,    0,    0,    0,    0,    0,   15,   77,    0,
   17,    0,   78,   79,  767,   93,   80,    0,    0,    0,
    0,    0,   85,   86,    0,   73,    6,    0,    8,    9,
   10,   74,   75,    0,   76,   11,   12,   13,    0,    0,
    0,    0,   88,   89,   90,    0,    0,    0,    0,    0,
   91,   15,   77,    0,   17,    0,   78,   79,    0,    0,
   80,    0,    0,   93,    0,    0,   85,   86,   81,    0,
   87,    0,  110,   82,    0,   83,    0,    0,    0,  478,
    0,    0,   92,    0,    0,    0,   88,   89,   90,  158,
  158,  158,    0,  158,   91,    6,    7,    8,    9,   10,
    0,    0,  474,    0,   11,   12,   13,  158,  158,  488,
  489,   58,    0,    0,    0,    0,   74,   75,    0,   76,
   15,   93,   16,    0,    0,    0,   81,    0,   87,    0,
  110,   82,    0,   83,    0,    0,    0,   77,    0,   17,
  158,   78,   79,    0,   78,   80,    0,   78,    0,    0,
   78,   85,   86,  492,    0,   93,   92,    0,    0,    0,
    0,    0,    0,    0,   78,   78,    0,   78,    0,   78,
    0,   88,   89,   90,  158,   93,    0,    0,    0,   91,
   93,  333,    0,    0,    0,   91,   93,    0,   91,    0,
    0,   81,    0,   87,    0,  361,   82,    0,   83,   78,
   78,    0,   91,   91,    0,   91,    0,    0,    0,    0,
    0,    0,  477,   73,   92,    0,    0,    0,    0,   74,
   75,    0,   76,  349,  350,    6,    7,    8,    9,   10,
   78,   78,  351,    0,   11,   12,   13,   91,    0,    0,
   77,    0,   17,    0,   78,   79,  362,    0,   80,    0,
   15,   93,   16,    0,   85,   86,   81,    0,   87,    0,
  110,   82,    0,   83,    0,    0,    0,    0,    0,   91,
    0,    0,    0,    0,   88,   89,   90,    0,    0,   92,
    0,    0,   91,    0,    0,    0,  488,   73,    0,    0,
   93,    0,    0,   74,   75,   81,   76,   87,    0,  110,
   82,    0,   83,    0,    0,    0,  158,  158,  159,  159,
  159,    0,  159,    0,   77,    0,   17,    0,   78,   79,
    0,    6,   80,    8,    9,   10,  159,  159,   85,   86,
   11,   12,   13,    0,  158,    0,    0,    0,    0,    0,
    0,  373,    0,    0,   92,   73,   15,    0,   88,   89,
   90,   74,   75,    0,   76,   93,   91,    0,    0,  159,
   81,    0,   87,    0,  110,   82,    0,   83,    0,    0,
    0,   78,   77,    0,   17,    0,   78,   79,    0,    0,
   80,    0,    0,   92,    0,    0,   85,   86,    0,    0,
    0,   78,    0,  159,    0,    0,   78,   78,   78,   78,
   78,   78,   78,    0,    0,    0,   88,   89,   90,   91,
   73,    0,    0,    0,   91,  394,   74,   75,    0,   76,
    0,    0,    0,    0,    0,    0,   93,    0,    0,   91,
    0,   81,    0,   87,   91,  110,   82,   77,   83,   17,
   88,   78,   79,   88,    0,   80,    0,    0,   92,    0,
    0,   85,   86,    0,    0,    0,    0,   88,   88,    0,
   88,    0,   88,    0,    0,    0,    0,    0,    0,    0,
    0,   88,   89,   90,    0,   73,    0,    0,    0,   91,
    0,   74,   75,    0,   76,    0,  426,    0,    0,    0,
    0,   93,   88,    0,    0,    0,   81,    0,   87,    0,
  110,   82,   77,   83,   17,    0,   78,   79,    0,    0,
   80,    0,    0,  160,   73,    0,   85,   86,    0,   92,
   74,   75,    0,   76,   88,  159,  159,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   88,   89,   90,    0,
    0,   77,    0,   17,   91,   78,   79,    0,    0,   80,
    0,  448,    0,  159,    0,   85,   86,    0,   93,    0,
    0,    0,    0,   81,    0,   87,    0,  612,   82,    0,
   83,    0,    0,    0,    0,   88,   89,   90,    0,   73,
    0,    0,    0,   91,   92,   74,   75,    0,   76,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   77,    0,   17,    0,
   78,   79,    0,    0,   80,    0,   94,   93,  613,   94,
   85,   86,   81,    0,   87,    0,  110,   82,    0,   83,
    0,    0,    0,   94,   94,    0,    0,    0,    0,    0,
   88,   89,   90,  628,    0,    0,    0,    0,   91,    0,
   73,   92,    0,    0,    0,    0,   74,   75,    0,   76,
   93,    0,    0,    0,   88,   81,    0,   87,   94,  110,
   82,    0,   83,    0,    0,    0,    0,   77,  165,   17,
  165,   78,   79,    0,   88,   80,  635,    0,    0,   88,
   88,   85,   86,    0,    0,    0,   32,  165,    0,    0,
   94,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   92,   88,   89,   90,    0,   73,    0,    0,    0,   91,
    0,   74,   75,    0,   76,   93,    0,    0,    0,    0,
   81,    0,   87,    0,  110,   82,    0,   83,    0,    0,
    0,    0,   77,    0,   17,   83,   78,   79,   83,    0,
   80,  637,    0,   92,    0,    0,   85,   86,    0,    0,
    0,    0,   83,   83,    0,   83,    0,   83,    0,    0,
    0,    0,    0,    0,    0,    0,   88,   89,   90,    0,
    0,    0,   73,    0,   91,    0,    0,    0,   74,   75,
    0,   76,    0,   93,    0,    0,    0,   83,   81,    0,
   87,    0,  110,   82,    0,   83,    0,    0,    0,   77,
    0,   17,    0,   78,   79,    0,    0,   80,   92,  639,
    0,    0,    0,   85,   86,    0,    0,    0,   83,   83,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   94,   73,    0,   88,   89,   90,    0,   74,   75,    0,
   76,   91,    0,    0,    0,    0,    0,   93,    0,    0,
   94,    0,   81,    0,   87,    0,  110,   82,   77,   83,
   17,    0,   78,   79,    0,    0,   80,    0,    0,    0,
    0,    0,   85,   86,   73,    0,   92,    0,    0,    0,
   74,   75,    0,   76,    0,  165,  165,  165,  165,  165,
  165,    0,   88,   89,   90,  165,  165,  165,    0,    0,
   91,   77,    0,   17,    0,   78,   79,  656,    0,   80,
    0,    0,   93,  165,    0,   85,   86,   81,    0,   87,
    0,   84,   82,    0,   83,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   88,   89,   90,    0,   73,
   92,    0,    0,   91,    0,   74,   75,    0,   76,    0,
    0,  239,    0,    0,    0,    0,  239,    0,  239,   83,
  239,  239,    0,  239,    0,    0,   77,    0,   17,    0,
   78,   79,    0,    0,   80,    0,    0,    0,    0,   83,
   85,   86,    0,    0,   83,   83,   83,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   88,   89,   90,    0,    0,   92,    0,   73,   91,    0,
    0,  239,    0,   74,   75,   89,   76,    0,    0,    0,
   89,    0,   89,    0,   89,   89,    0,   89,    0,    0,
    0,    0,    0,    0,   77,    0,   17,    0,   78,   79,
   92,    0,   80,    0,  239,    0,    0,    0,   85,   86,
    0,    0,    0,    0,  242,    0,    0,    0,    0,  242,
    0,  242,    0,  242,  242,    0,  242,    0,   88,   89,
   90,   73,    0,    0,    0,    0,   91,   74,   75,    0,
   76,    0,  349,    0,    6,    7,    8,    9,   10,    0,
    0,  351,    0,   11,   12,   13,    0,    0,   77,    0,
   17,    0,   78,   79,    0,    0,   80,    0,   89,   15,
    0,   16,   85,   86,  242,    0,    0,    0,    0,  240,
    0,    0,    0,    0,  240,    0,  240,    0,  240,  240,
    0,  240,   88,   89,   90,    0,   73,    0,    0,    0,
   91,    0,   74,   75,    0,   76,    0,  242,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  760,    0,
    0,    0,    0,   77,    0,   17,    0,   78,   79,    0,
    0,   80,    0,    0,    0,  239,    0,   85,   86,  240,
    0,  239,  239,   93,  239,    0,    0,    0,   81,    0,
   87,    0,   84,   82,    0,   83,    0,   88,   89,   90,
    0,    0,  239,    0,  239,   91,  239,  239,    0,    0,
  239,    0,  240,    0,    0,    0,  239,  239,    0,    0,
    0,    0,   93,    0,    0,    0,    0,   81,    0,   87,
    0,  110,   82,    0,   83,    0,  239,  239,  239,   89,
    0,    0,    0,    0,  239,   89,   89,    0,   89,    0,
    6,    7,    8,    9,   10,    0,    0,    0,    0,   11,
   12,   13,    0,    0,    0,    0,   89,    0,   89,    0,
   89,   89,    0,    0,   89,   15,   92,   16,  242,    0,
   89,   89,    0,    0,  242,  242,   93,  242,    0,    0,
    0,   81,    0,  191,    0,  110,   82,    0,   83,    0,
   89,   89,   89,    0,    0,  242,    0,  242,   89,  242,
  242,    0,    0,  242,    0,   92,    0,    0,    0,  242,
  242,    0,    0,    0,    0,   93,    0,    0,    0,    0,
   81,    0,  193,    0,  110,   82,    0,   83,    0,  242,
  242,  242,    0,  240,    0,    0,    0,  242,    0,  240,
  240,   86,  240,    0,   86,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   86,   86,
  240,   86,  240,   86,  240,  240,    0,    0,  240,   92,
    0,    0,    0,    0,  240,  240,    0,    0,    0,   93,
    0,    0,    0,    0,   81,    0,  195,    0,  110,   82,
    0,   83,    0,   86,  240,  240,  240,   73,    0,    0,
  177,    0,  240,   74,   75,    0,   76,    0,   92,    0,
    0,    0,    0,    0,    0,  177,    0,  177,    0,    0,
    0,    0,    0,    0,   77,   86,   17,    0,   78,   79,
    0,    0,   80,  148,  148,  148,   73,  148,   85,   86,
    0,    0,   74,   75,   93,   76,    0,    0,    0,   81,
    0,  199,  148,  110,   82,    0,   83,    0,   88,   89,
   90,    0,    0,   77,    0,   17,   91,   78,   79,    0,
    0,   80,   92,    0,    0,    0,    0,   85,   86,   27,
    0,    0,    0,   93,  148,    0,    0,    0,   81,    0,
  201,    0,  110,   82,    0,   83,    0,   88,   89,   90,
   73,    0,    0,    0,    0,   91,   74,   75,    0,   76,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   77,    0,   17,
    0,   78,   79,    0,    0,   80,    0,   92,    0,   73,
    0,   85,   86,    0,    0,   74,   75,   93,   76,    0,
    0,    0,   81,    0,   87,    0,  110,   82,    0,   83,
    0,   88,   89,   90,    0,   86,   77,    0,   17,   91,
   78,   79,    0,    0,   80,    0,   92,    0,    0,    0,
   85,   86,    0,    0,    0,   86,    0,    0,    0,    0,
   86,   86,   86,    0,    0,    0,    0,    0,    0,    0,
   88,   89,   90,   73,    0,    0,    0,    0,   91,   74,
   75,    0,   76,    0,   27,   27,   27,   27,   27,    0,
    0,    0,    0,   27,   27,   27,    0,    0,    0,    0,
   77,    0,   17,    0,   78,   79,    0,    0,   80,   27,
   92,  177,    0,    0,   85,   86,    0,    0,    0,    0,
  148,  148,  148,  148,  148,  148,    0,    0,    0,    0,
  148,  148,  148,    0,   88,   89,   90,    0,   73,    0,
    0,    0,   91,    0,   74,   75,  148,   76,   96,   96,
    0,   96,    0,   96,   96,    0,   96,   96,   96,    0,
    0,    0,    0,    0,    0,   77,    0,   17,    0,   78,
   79,    0,   96,   80,   96,    0,    0,   73,    0,   85,
   86,    0,    0,   74,   75,    0,   76,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   88,
   89,   90,   96,    0,   77,   96,   17,   91,   78,   79,
    0,   79,   80,    0,   79,    0,    0,   79,   85,   86,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   79,   79,    0,   79,   96,   79,    0,   88,   89,
   90,  401,    0,    0,    0,    0,   91,   74,   75,    0,
   76,    0,    0,    0,    0,    0,    0,    0,    0,  170,
  170,  170,    0,  170,    0,    0,   79,   79,   77,    0,
   17,    0,   78,   79,    0,    0,   80,  170,  170,    0,
    0,    0,   85,   86,    0,   98,   98,    0,   98,   98,
   98,   98,   98,   98,   98,   98,    0,   79,   79,    0,
    0,    0,   88,   89,   90,    0,   98,   98,    0,   98,
   91,   98,   96,   96,    0,   96,    0,   96,   96,   96,
   96,   96,   96,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   31,   96,    0,   96,    0,   96,   98,
    0,   98,   98,    0,  170,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   45,   45,    0,
    0,   45,   45,   45,   45,   45,   96,   45,    0,   96,
    0,    0,   98,   98,    0,    0,    0,    0,   45,   45,
    0,   45,    0,   45,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   96,
   96,   96,   96,   96,   96,   96,   96,   96,    0,   96,
   96,    0,   96,   45,   45,  182,  173,    0,    0,    0,
  180,  178,    0,  179,    0,  181,    0,  182,  173,    0,
    0,    0,  180,  178,    0,  179,    0,  181,   79,  167,
    0,  168,    0,    0,   45,   45,    0,    0,  668,  182,
  173,  167,    0,  168,  180,  178,    0,  179,   79,  181,
    0,    0,    0,   79,   79,   79,   79,   79,   79,   79,
    0,  570,  172,  167,    0,  168,  170,  170,  170,  170,
  170,  170,    0,    0,  172,    0,  170,  170,  170,    0,
    0,    0,    0,    0,    0,  182,  173,    0,    0,    0,
  180,  178,  171,  179,  170,  181,  172,    0,    0,    0,
    0,    0,    0,   98,  171,    0,    0,    0,    0,  167,
    0,  168,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   98,    0,    0,  171,    0,   98,   98,
   98,   98,   98,   98,   98,    0,   98,   98,    0,   98,
    0,  658,  172,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   96,   96,   96,   96,   96,
   96,   96,    0,   96,   96,    0,   96,    0,  182,  173,
    0,    0,  171,  180,  178,   45,  179,    0,  181,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  712,
    0,    0,  167,    0,  168,   45,    0,    0,    0,    0,
   45,   45,   45,   45,   45,   45,   45,    0,    0,    0,
    0,    0,  182,  173,    0,    0,    0,  180,  178,    0,
  179,    0,  181,    0,    0,  172,    0,    0,    0,    0,
    0,    0,    0,  569,    0,    0,  167,    0,  168,    0,
    0,    0,    0,    0,    0,  667,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  171,    0,    0,  166,  169,
  170,  174,  175,  176,  177,    0,    0,    0,    0,  172,
  166,  169,  170,  174,  175,  176,  177,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   16,    0,    0,
    0,    0,  166,  169,  170,  174,  175,  176,  177,  171,
   73,    0,    0,   73,    0,   73,   73,   73,    0,    0,
    0,    0,   74,    0,    0,   74,    0,   74,   74,   74,
   73,   73,    0,   73,    0,   73,    0,    0,    0,    0,
    0,    0,   74,   74,    0,   74,    0,   74,  166,  169,
  170,  174,  175,  176,  177,    0,    0,    0,    0,    0,
    0,   80,    0,    0,   80,   73,   73,   80,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   74,   74,    0,
    0,   80,   80,    0,   80,    0,   80,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   73,   73,   81,    0,
    0,   81,    0,    0,   81,    0,    0,    0,   74,   74,
    0,  156,  156,  156,    0,  156,   80,   80,   81,   81,
    0,   81,    0,   81,    0,    0,    0,    0,    0,  156,
  156,  166,  169,  170,  174,  175,  176,  177,   82,    0,
    0,   82,    0,    0,   82,    0,    0,   80,   80,   84,
    0,    0,   84,   81,   81,    0,    0,    0,   82,   82,
    0,   82,    0,   82,    0,    0,   84,   84,    0,   84,
    0,   84,    0,    0,    0,  166,  169,  170,  174,  175,
  176,  177,    0,    0,   81,   81,    0,  269,  269,  269,
    0,  269,    0,   82,   82,    0,  156,    0,    0,    0,
    0,   84,   84,    0,    0,  269,  269,    0,  273,  273,
  273,    0,  273,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   82,   82,  273,  273,    0,    0,
    0,    0,   84,   84,    0,    0,    0,   73,  269,  147,
  147,  147,    0,  147,    0,    0,    0,    0,    0,   74,
    0,    0,  278,  278,  278,    0,  278,   73,  147,  273,
    0,    0,   73,   73,   73,   73,   73,   73,   73,   74,
  278,  278,  269,    0,   74,   74,   74,   74,   74,   74,
   74,    0,    0,  149,  149,  149,    0,  149,   80,    0,
  147,    0,    0,  273,    0,    0,    0,    0,    0,    0,
    0,    0,  149,  278,  254,    0,    0,  254,   80,    0,
    0,    0,    0,   80,   80,   80,   80,   80,    0,    0,
    0,  254,  254,    0,  254,   81,    0,    0,  156,  156,
  156,  156,  156,  156,  149,    0,    0,  278,  156,  156,
  156,    0,    0,    0,    0,   81,    0,    0,    0,    0,
   81,   81,   81,   81,  156,    0,  156,  258,    0,    0,
  258,    0,    0,    0,    0,   82,    0,    0,    0,    0,
    0,    0,    0,   84,  258,  258,    0,  258,    0,    0,
    0,    0,    0,    0,    0,   82,  254,    0,  254,    0,
   82,   82,   82,   84,    0,    0,    0,    0,   84,   84,
   84,    0,    0,    0,  269,  269,  269,  269,  269,  269,
    0,    0,    0,    0,  269,  269,  269,    0,    0,    0,
    0,    0,    0,    0,    0,  273,  273,  273,  273,  273,
  273,  236,  269,    0,  236,  273,  273,  273,    0,  258,
    0,  258,    0,    0,    0,    0,    0,    0,  236,  236,
    0,  236,    0,  273,    0,    0,  147,  147,    0,  147,
    0,    0,    0,    0,    0,    0,  147,  147,  147,  278,
  278,  278,  278,  278,  278,  237,    0,    0,  237,  278,
  278,  278,  147,    0,  147,    0,    0,    0,    0,    0,
  177,    0,  237,  237,    0,  237,    0,  278,    0,    0,
  149,  149,    0,  149,    0,  177,    0,  177,    0,    0,
  149,  149,  149,  236,    0,  236,  150,  150,  150,  254,
  150,  254,  254,  254,  254,  254,  149,    0,  149,    0,
  254,  254,  254,    0,    0,  150,    0,  231,    0,    0,
    0,    0,    0,    0,    0,  254,  254,    0,  254,    0,
    0,  231,  231,    0,  231,    0,  230,  237,    0,  237,
    0,    0,    0,    0,    0,    0,    0,  150,    0,   19,
  230,  230,  258,  230,  258,  258,  258,  258,  258,    0,
    0,    0,    0,  258,  258,  258,    0,  177,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  258,  258,
    0,  258,  177,    0,  177,    0,  177,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  231,    0,  231,  177,
    0,  177,    0,  177,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  177,  230,  177,  230,    0,    0,
    0,    0,    0,    0,    0,    0,  236,    0,  236,  236,
  236,  236,  236,    0,    0,    0,    0,  236,  236,  236,
    0,  185,  185,  185,    0,  185,  224,    0,    0,    0,
    0,    0,  236,  236,    0,  236,    0,    0,    0,  185,
  185,    0,    0,    0,    0,  227,    0,    0,    0,    0,
  237,    0,  237,  237,  237,  237,  237,   18,   23,    0,
    0,  237,  237,  237,   19,   19,   19,   19,   19,    0,
    0,    0,  185,   19,   19,   19,  237,  237,    0,  237,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   19,
    0,  177,    0,  150,  150,  150,  150,  150,  150,    0,
    0,    0,    0,  150,  150,  150,  185,    0,    0,  231,
    0,  231,  231,  231,  231,  231,    0,    0,    0,  150,
  231,  231,  231,  141,  141,  141,    0,  141,  230,    0,
  230,  230,  230,  230,  230,  231,  231,    0,  231,  230,
  230,  230,  141,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  230,  230,    0,  230,    0,  224,
    0,  224,  224,  224,  224,  224,    0,    0,    0,    0,
  224,  224,  224,    0,  141,    0,    0,    0,  227,    0,
  227,  227,  227,  227,  227,    0,  224,    0,  177,  227,
  227,  227,    0,   23,   23,   23,   23,   23,    0,    0,
    0,    0,   23,   23,   23,  227,    0,  177,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   23,    0,
  177,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  185,  185,
  185,  185,  185,  185,    0,    0,    0,    0,  185,  185,
  185,    0,    0,    0,    5,    0,    6,    7,    8,    9,
   10,    0,    0,    0,    0,   11,   12,   13,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   14,   15,    0,   16,   17,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  141,  141,  141,  141,  141,  141,    0,    0,    0,    0,
  141,  141,  141,
};
const short yycheck[] = {                                      38,
   43,   44,   26,   27,   28,   47,   52,    3,    4,  271,
   19,   20,   20,  259,    3,    4,    3,    4,  163,  231,
    3,    4,  211,  125,  236,  155,    3,    4,  124,  120,
  232,  187,  483,   53,   11,   12,   13,   20,   34,   58,
  207,   40,  115,   20,   87,   34,   40,   34,  316,  272,
   41,   34,   46,   30,  123,  148,   80,   34,   40,   41,
  123,  123,  139,   30,   46,  139,  103,  104,  105,   61,
   47,  108,  109,   78,   79,   52,   53,  121,   40,   84,
   40,   91,   42,   44,   40,   52,   42,   41,   40,   94,
   67,  285,   91,   40,  118,   42,   44,   91,   58,   59,
   67,  231,  107,  206,   58,  110,  236,    4,  128,   91,
   40,   59,  208,   61,  205,   40,   40,   42,   40,  143,
   42,   37,   41,  409,   59,   44,   42,   43,   40,   45,
   42,   47,  115,  322,  227,   91,  113,   34,  115,   91,
   59,  271,   44,  139,  121,  188,   59,   40,  191,   42,
  193,  128,  195,  320,  121,  257,  199,   23,  201,  500,
  197,  185,  186,   40,  125,  125,   40,  244,  145,  325,
  244,  148,  149,   87,   40,   41,   42,  256,  145,   91,
  224,   44,  149,   41,  228,   51,   44,   40,  257,  258,
  233,  211,   37,  256,  645,  257,  258,   42,   43,   40,
   45,   59,   47,  282,   70,  473,  547,  337,  338,   44,
  313,   40,  125,   42,   40,  318,   42,   91,   40,   44,
  506,  264,   42,  125,   59,   40,   44,  230,  252,  206,
   46,  572,  241,  242,   59,  238,   37,   38,   91,  123,
  283,   42,   43,  246,   45,   61,   47,  224,  244,  264,
  227,  228,   59,  245,   40,  247,   42,  224,  124,  242,
   41,  228,  125,   44,  307,   91,  285,  257,  258,   91,
  136,  276,   58,  264,  317,   91,   91,  191,  261,  193,
   40,  195,  505,  197,  261,  199,  285,  201,  433,   40,
  125,   42,  481,   94,  256,  451,   59,  257,  258,  123,
  324,  257,  322,   93,  298,  299,   22,  301,  438,   41,
  257,  258,   44,  123,  261,  262,  298,  299,  125,  301,
  123,  345,  524,  124,   41,  285,  456,   59,   44,  285,
  282,   91,  257,  316,   50,  257,  313,  285,  285,  316,
   91,  318,  208,  352,  353,  353,  419,  420,  537,   40,
  387,  388,   40,   40,   42,  398,  361,   40,  525,   42,
  368,  464,  125,  285,  257,  651,  285,   41,   41,  465,
  353,   87,  463,  285,  470,  505,  353,   41,  469,  295,
  296,  165,  166,  167,   58,  368,   59,  171,  172,  173,
  174,  175,  176,  177,  178,  179,  180,  181,  182,  115,
   91,  267,   40,  665,   42,   41,   40,   41,  411,  412,
  555,  285,  415,  437,   40,  457,   42,  125,  521,  522,
   93,  430,  431,  139,  125,  528,  529,  285,  257,  145,
   40,  257,  258,   40,  256,  261,  262,  257,  258,  422,
  486,  256,  419,  420,   41,  422,   41,   44,  431,  294,
  295,  296,  419,  420,  257,  258,  285,   91,  461,  285,
  282,  481,   59,  466,  467,  468,  490,  282,  471,  472,
   41,  257,  258,  387,  388,  191,  259,  193,  261,  195,
  457,  197,  256,  199,   91,  201,   40,  464,   42,  701,
  473,  703,  293,  294,  295,  296,  473,  464,  259,  285,
  261,  285,  286,  749,   41,   46,  483,  123,  224,  486,
  261,  262,  555,  759,  123,   41,  519,  537,   44,  486,
   61,   40,  565,   42,  521,  522,  242,  551,  244,  123,
   40,  555,   42,   59,  285,  665,  404,   91,  406,   41,
   59,  686,   44,  586,  521,  522,   59,  590,  591,  592,
   91,  528,  529,  285,  521,  522,  559,   59,   40,  555,
  344,  528,  529,  587,   59,   40,  555,   42,  555,  257,
  258,  701,  555,  703,  257,  258,  619,  679,  555,  123,
  623,   91,   40,   41,  123,  730,  731,  630,  597,  598,
  598,   40,   61,   42,   44,  379,  601,  313,   40,  465,
   42,  647,  285,  645,  470,  601,    0,  612,  611,   58,
   59,  654,  601,  282,  601,  598,   91,  660,  601,  257,
  258,  598,   37,   38,  601,  533,  261,   42,   43,  672,
   45,  257,   47,   91,  542,  261,  262,  264,   44,  642,
   41,  257,  258,  686,  428,   61,   40,  285,   42,   91,
   40,   41,  436,   59,  693,  123,   41,   58,   59,  285,
  699,   41,  686,  257,  258,   59,   44,   59,  645,  453,
  647,  387,  388,   58,  265,   41,  125,   33,   58,   94,
  647,   59,   38,   61,   40,   41,   42,   43,   44,   45,
   37,  734,   93,  123,  733,   42,   43,  125,   45,  738,
   47,   91,   58,   59,   41,   61,   58,  491,   41,  124,
   41,   44,  123,  257,  258,  431,  500,  756,  257,  258,
   93,   58,   37,   38,   41,  509,   59,   42,   43,   44,
   45,   41,   47,   41,  518,   91,   44,   44,  257,  258,
   41,   44,   44,   44,   59,   44,   61,  257,   63,  533,
   44,   59,   59,   41,   44,   40,   59,   42,  542,  285,
   59,  545,   41,  547,   41,   59,  285,  123,   33,  125,
  126,   41,   40,   38,   42,   40,  560,   42,   43,   94,
   45,   41,  257,  285,   44,  569,  261,  262,  572,  257,
  258,   37,   38,   93,   59,   61,   42,   43,  582,   45,
   44,   47,   44,  125,   41,  521,   91,   44,  257,  124,
  285,  259,  528,  261,  262,   59,  258,   59,  260,  261,
  262,   58,   59,   91,   41,  267,  268,  269,  258,  259,
  260,  261,  262,  125,   44,  265,  285,  267,  268,  269,
   41,  283,  125,  285,   44,   33,  257,  258,   94,   59,
   38,  261,   40,  283,   42,   43,   93,   45,  123,   59,
   93,  126,  256,  257,  258,  259,  260,  261,  262,   44,
   44,   59,   58,  267,  268,  269,   41,  292,  293,  294,
  295,  296,  287,  667,   59,   59,   93,   41,  282,  283,
   44,  285,  286,  257,  258,  259,  260,  261,  262,   44,
  256,  257,  258,  259,  260,  261,  262,  263,  264,  125,
  266,  267,  268,  269,  270,  257,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,   37,
  286,   59,  288,  289,   42,  123,  292,  125,  126,   47,
  256,   59,  298,  299,   41,   33,  293,  294,  295,  296,
   38,   41,   40,   93,   42,   43,   41,   45,   41,   44,
   41,  317,  318,  319,  320,  321,  322,  323,  125,  325,
  326,   59,  257,  258,   58,  290,  291,  292,  293,  294,
  295,  296,   41,   44,   41,   44,    0,   44,  125,  257,
  258,  256,  257,  258,  259,  260,  261,  262,  263,  264,
  285,  266,  267,  268,  269,  270,  125,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  125,   40,  292,   42,   41,
  125,   37,   44,  298,  299,  123,   42,   43,  126,   45,
   40,   47,   42,   41,   40,   59,   44,  293,  294,  295,
  296,   40,  317,  318,  319,  320,  321,  322,  323,   59,
  325,  326,   41,   41,   40,   44,   44,   58,  256,  257,
  258,  259,  260,  261,  262,  263,  264,   59,  266,  267,
  268,  269,  270,  261,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,  286,   59,
  288,  289,   59,   40,  292,   40,   41,   42,   59,   44,
  298,  299,   58,   33,  256,  257,  258,   59,   38,   59,
   40,  271,   42,   43,   59,   45,  256,   93,   40,  317,
  318,  319,  320,  321,  322,  323,   59,  325,  326,   59,
  258,  259,  260,  261,  262,   59,   40,  256,   59,  267,
  268,  269,   37,   38,   59,   59,   91,   42,   43,   41,
   45,  272,   47,   59,   41,  283,   59,  285,  256,  257,
  258,  259,  260,  261,  262,  263,  264,   41,  266,  267,
  268,  269,  270,   41,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,  286,   41,
  288,  289,   44,  123,  292,   59,  126,   59,  264,   59,
  298,  299,   59,   33,   40,   44,   58,   59,   38,   59,
   40,   59,   42,   43,   41,   45,   41,   59,   59,  317,
  318,  319,  320,  321,  322,  323,   59,  325,  326,   59,
   41,  125,  256,  257,  258,  259,  260,  261,  262,   93,
  123,   93,   41,  267,  268,  269,  125,  257,  258,  125,
   41,   41,  125,   40,   41,   42,  125,   44,  282,  283,
  125,  285,  286,   40,  125,   59,   41,  325,  259,  260,
  261,  262,   59,  622,   33,  285,  267,  268,  269,   38,
   49,   40,  485,   42,   43,  212,   45,  453,  258,  259,
  260,  261,  262,  123,  285,  125,  126,  267,  268,  269,
   59,  260,  261,  262,   91,  735,  737,  324,  267,  268,
  269,  338,  257,  283,  456,   37,   38,  252,  244,  345,
   42,   43,  319,   45,  505,   47,  256,  257,  258,  259,
  260,  261,  262,  263,  264,  422,  266,  267,  268,  269,
  270,   63,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  634,  288,  289,
  134,   41,  292,  601,  123,  545,  125,  126,  298,  299,
  347,   33,   94,  498,  262,  439,   38,   -1,   40,  686,
   42,   43,   -1,   45,   -1,  686,   -1,  317,  318,  319,
  320,  321,  322,  323,   -1,  325,  326,   59,  293,  294,
  295,  296,  124,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  258,  259,  260,  261,  262,  259,  260,  261,  262,  267,
  268,  269,   -1,  267,  268,  269,   -1,  257,  258,  259,
  260,  261,  262,  263,  264,  283,  266,  267,  268,  269,
  270,   -1,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,   -1,  288,  289,
   -1,  123,  292,   -1,  126,   -1,   -1,   59,  298,  299,
  257,  258,   33,   -1,   -1,   -1,   -1,   38,   -1,   40,
   -1,   42,   43,   -1,   45,   -1,   -1,  317,  318,  319,
  320,  321,  322,  323,   -1,  325,  326,  256,  257,  258,
  259,  260,  261,  262,  263,  264,   -1,  266,  267,  268,
  269,  270,   -1,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,   -1,  286,   -1,  288,
  289,   -1,   -1,  292,   -1,   -1,   -1,   -1,   -1,  298,
  299,   -1,   33,   -1,  123,   -1,   -1,   38,   -1,   40,
   -1,   42,   43,   -1,   45,   -1,   -1,   -1,  317,  318,
  319,  320,  321,  322,  323,  126,  325,  326,   59,  291,
  292,  293,  294,  295,  296,   -1,  256,   -1,  258,  259,
  260,  261,  262,   -1,   -1,  265,   -1,  267,  268,  269,
   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,  261,
  262,  263,  264,  283,  266,  267,  268,  269,  270,   -1,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,   -1,  288,  289,   -1,   -1,
  292,   -1,  123,   -1,   -1,  126,  298,  299,   -1,   33,
   -1,   59,   -1,   -1,   38,   -1,   40,   -1,   42,   43,
   -1,   45,   -1,   -1,   -1,  317,  318,  319,  320,  321,
  322,  323,   -1,  325,  326,   59,  258,  259,  260,  261,
  262,   -1,   -1,   -1,   -1,  267,  268,  269,   -1,  258,
  259,  260,  261,  262,   -1,   -1,   -1,   -1,  267,  268,
  269,  283,   -1,  285,   -1,   -1,  257,  258,  259,  260,
  261,  262,  263,  264,  283,  266,  267,  268,  269,   33,
   -1,   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   43,
   -1,   45,  283,  284,  285,  286,   -1,  288,  289,  123,
   -1,  292,  126,   -1,   -1,   59,   -1,  298,  299,  258,
  259,  260,  261,  262,   -1,   -1,   -1,   -1,  267,  268,
  269,   -1,   -1,   -1,   -1,   -1,   -1,  318,  319,  320,
   -1,   -1,   -1,   -1,  283,  326,  257,  258,  259,  260,
  261,  262,  263,  264,   -1,  266,  267,  268,  269,  270,
   -1,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,   -1,  288,  289,  123,
   -1,  292,  126,   -1,   -1,   -1,   -1,  298,  299,   -1,
   33,   -1,   -1,   -1,   -1,   38,   -1,   40,   -1,   42,
   43,   -1,   45,   -1,   -1,   -1,  317,  318,  319,  320,
  321,  322,  323,   -1,  325,  326,   59,   -1,  256,   -1,
  258,   -1,  260,  261,  262,   -1,   -1,   -1,   -1,  267,
  268,  269,   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,
   44,   -1,   -1,  257,  258,  283,   -1,   -1,  286,  263,
  264,   -1,  266,   -1,   58,   59,  270,   -1,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,   -1,
  284,   -1,  286,   -1,  288,  289,   -1,   -1,  292,   -1,
  123,   -1,   -1,  126,  298,  299,   -1,   33,   -1,   93,
   -1,   -1,   38,   -1,   40,   -1,   42,   43,   -1,   45,
   -1,   -1,   -1,  317,  318,  319,  320,  321,  322,  323,
   -1,  325,  326,  257,  258,   -1,   -1,   -1,   -1,  263,
  264,  125,  266,   -1,   -1,   -1,  270,  123,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,   -1,
  284,   -1,  286,   -1,  288,  289,   -1,   -1,  292,   40,
   41,   42,   -1,   44,  298,  299,   -1,   33,   -1,   -1,
   -1,   -1,   38,   -1,   40,   -1,   42,   43,   59,   45,
   -1,   -1,   -1,  317,  318,  319,  320,  321,  322,  323,
  126,  325,  326,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  256,   -1,  258,   -1,  260,  261,  262,   -1,
   91,   33,   -1,  267,  268,  269,   38,   -1,   40,   -1,
   42,   43,   -1,   45,  257,  258,   -1,   -1,   -1,  283,
  263,  264,  286,  266,   -1,   -1,   -1,  270,   -1,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
   -1,  284,   -1,  286,   -1,  288,  289,   -1,   -1,  292,
  126,   -1,   -1,   -1,   -1,  298,  299,   -1,   -1,   -1,
  256,  265,  258,  259,  260,  261,  262,   -1,   -1,  621,
   -1,  267,  268,  269,  317,  318,  319,  320,  321,  322,
  323,  285,  325,  326,   -1,   -1,   33,  283,   -1,   -1,
   -1,   38,   -1,   40,  126,   42,   43,   -1,   45,   46,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  256,  257,  258,   -1,  260,  261,  262,  263,  264,   -1,
  266,  267,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   41,   -1,  685,   44,   -1,   -1,  283,  284,   -1,
  286,   -1,  288,  289,   91,   -1,  292,   -1,   58,   59,
   -1,   61,  298,  299,  706,   -1,   -1,  709,   -1,  711,
   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  720,   -1,
   -1,   -1,  318,  319,  320,   -1,  123,   -1,   -1,  126,
  326,  257,  258,   93,  260,  261,  262,  263,  264,   33,
  266,  267,  268,  269,   38,   -1,   40,   -1,   42,   43,
  752,   45,   -1,   -1,   -1,   -1,   -1,  283,  284,   -1,
  286,   -1,  288,  289,  766,  125,  292,   -1,   -1,   -1,
   -1,   -1,  298,  299,   -1,  257,  258,   -1,  260,  261,
  262,  263,  264,   -1,  266,  267,  268,  269,   -1,   -1,
   -1,   -1,  318,  319,  320,   -1,   -1,   -1,   -1,   -1,
  326,  283,  284,   -1,  286,   -1,  288,  289,   -1,   -1,
  292,   -1,   -1,   33,   -1,   -1,  298,  299,   38,   -1,
   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,  123,
   -1,   -1,  126,   -1,   -1,   -1,  318,  319,  320,   40,
   41,   42,   -1,   44,  326,  258,  259,  260,  261,  262,
   -1,   -1,  265,   -1,  267,  268,  269,   58,   59,  256,
  257,  258,   -1,   -1,   -1,   -1,  263,  264,   -1,  266,
  283,   33,  285,   -1,   -1,   -1,   38,   -1,   40,   -1,
   42,   43,   -1,   45,   -1,   -1,   -1,  284,   -1,  286,
   91,  288,  289,   -1,   38,  292,   -1,   41,   -1,   -1,
   44,  298,  299,  123,   -1,  265,  126,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   -1,   61,   -1,   63,
   -1,  318,  319,  320,  125,  285,   -1,   -1,   -1,  326,
  290,   93,   -1,   -1,   -1,   41,   33,   -1,   44,   -1,
   -1,   38,   -1,   40,   -1,   42,   43,   -1,   45,   93,
   94,   -1,   58,   59,   -1,   61,   -1,   -1,   -1,   -1,
   -1,   -1,  256,  257,  126,   -1,   -1,   -1,   -1,  263,
  264,   -1,  266,  256,  257,  258,  259,  260,  261,  262,
  124,  125,  265,   -1,  267,  268,  269,   93,   -1,   -1,
  284,   -1,  286,   -1,  288,  289,   93,   -1,  292,   -1,
  283,   33,  285,   -1,  298,  299,   38,   -1,   40,   -1,
   42,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,  125,
   -1,   -1,   -1,   -1,  318,  319,  320,   -1,   -1,  126,
   -1,   -1,  326,   -1,   -1,   -1,  256,  257,   -1,   -1,
   33,   -1,   -1,  263,  264,   38,  266,   40,   -1,   42,
   43,   -1,   45,   -1,   -1,   -1,  257,  258,   40,   41,
   42,   -1,   44,   -1,  284,   -1,  286,   -1,  288,  289,
   -1,  258,  292,  260,  261,  262,   58,   59,  298,  299,
  267,  268,  269,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,  123,   -1,   -1,  126,  257,  283,   -1,  318,  319,
  320,  263,  264,   -1,  266,   33,  326,   -1,   -1,   91,
   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,
   -1,  265,  284,   -1,  286,   -1,  288,  289,   -1,   -1,
  292,   -1,   -1,  126,   -1,   -1,  298,  299,   -1,   -1,
   -1,  285,   -1,  125,   -1,   -1,  290,  291,  292,  293,
  294,  295,  296,   -1,   -1,   -1,  318,  319,  320,  265,
  257,   -1,   -1,   -1,  326,   93,  263,  264,   -1,  266,
   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,   -1,  285,
   -1,   38,   -1,   40,  290,   42,   43,  284,   45,  286,
   41,  288,  289,   44,   -1,  292,   -1,   -1,  126,   -1,
   -1,  298,  299,   -1,   -1,   -1,   -1,   58,   59,   -1,
   61,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  318,  319,  320,   -1,  257,   -1,   -1,   -1,  326,
   -1,  263,  264,   -1,  266,   -1,   93,   -1,   -1,   -1,
   -1,   33,   93,   -1,   -1,   -1,   38,   -1,   40,   -1,
   42,   43,  284,   45,  286,   -1,  288,  289,   -1,   -1,
  292,   -1,   -1,  256,  257,   -1,  298,  299,   -1,  126,
  263,  264,   -1,  266,  125,  257,  258,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  318,  319,  320,   -1,
   -1,  284,   -1,  286,  326,  288,  289,   -1,   -1,  292,
   -1,   93,   -1,  285,   -1,  298,  299,   -1,   33,   -1,
   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   43,   -1,
   45,   -1,   -1,   -1,   -1,  318,  319,  320,   -1,  257,
   -1,   -1,   -1,  326,  126,  263,  264,   -1,  266,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  284,   -1,  286,   -1,
  288,  289,   -1,   -1,  292,   -1,   41,   33,   93,   44,
  298,  299,   38,   -1,   40,   -1,   42,   43,   -1,   45,
   -1,   -1,   -1,   58,   59,   -1,   -1,   -1,   -1,   -1,
  318,  319,  320,   59,   -1,   -1,   -1,   -1,  326,   -1,
  257,  126,   -1,   -1,   -1,   -1,  263,  264,   -1,  266,
   33,   -1,   -1,   -1,  265,   38,   -1,   40,   93,   42,
   43,   -1,   45,   -1,   -1,   -1,   -1,  284,   40,  286,
   42,  288,  289,   -1,  285,  292,   59,   -1,   -1,  290,
  291,  298,  299,   -1,   -1,   -1,   58,   59,   -1,   -1,
  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  126,  318,  319,  320,   -1,  257,   -1,   -1,   -1,  326,
   -1,  263,  264,   -1,  266,   33,   -1,   -1,   -1,   -1,
   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,
   -1,   -1,  284,   -1,  286,   41,  288,  289,   44,   -1,
  292,   59,   -1,  126,   -1,   -1,  298,  299,   -1,   -1,
   -1,   -1,   58,   59,   -1,   61,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  318,  319,  320,   -1,
   -1,   -1,  257,   -1,  326,   -1,   -1,   -1,  263,  264,
   -1,  266,   -1,   33,   -1,   -1,   -1,   93,   38,   -1,
   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,  284,
   -1,  286,   -1,  288,  289,   -1,   -1,  292,  126,   59,
   -1,   -1,   -1,  298,  299,   -1,   -1,   -1,  124,  125,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  265,  257,   -1,  318,  319,  320,   -1,  263,  264,   -1,
  266,  326,   -1,   -1,   -1,   -1,   -1,   33,   -1,   -1,
  285,   -1,   38,   -1,   40,   -1,   42,   43,  284,   45,
  286,   -1,  288,  289,   -1,   -1,  292,   -1,   -1,   -1,
   -1,   -1,  298,  299,  257,   -1,  126,   -1,   -1,   -1,
  263,  264,   -1,  266,   -1,  257,  258,  259,  260,  261,
  262,   -1,  318,  319,  320,  267,  268,  269,   -1,   -1,
  326,  284,   -1,  286,   -1,  288,  289,   93,   -1,  292,
   -1,   -1,   33,  285,   -1,  298,  299,   38,   -1,   40,
   -1,   42,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  318,  319,  320,   -1,  257,
  126,   -1,   -1,  326,   -1,  263,  264,   -1,  266,   -1,
   -1,   33,   -1,   -1,   -1,   -1,   38,   -1,   40,  265,
   42,   43,   -1,   45,   -1,   -1,  284,   -1,  286,   -1,
  288,  289,   -1,   -1,  292,   -1,   -1,   -1,   -1,  285,
  298,  299,   -1,   -1,  290,  291,  292,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  318,  319,  320,   -1,   -1,  126,   -1,  257,  326,   -1,
   -1,   93,   -1,  263,  264,   33,  266,   -1,   -1,   -1,
   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,
   -1,   -1,   -1,   -1,  284,   -1,  286,   -1,  288,  289,
   58,   -1,  292,   -1,  126,   -1,   -1,   -1,  298,  299,
   -1,   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,   38,
   -1,   40,   -1,   42,   43,   -1,   45,   -1,  318,  319,
  320,  257,   -1,   -1,   -1,   -1,  326,  263,  264,   -1,
  266,   -1,  256,   -1,  258,  259,  260,  261,  262,   -1,
   -1,  265,   -1,  267,  268,  269,   -1,   -1,  284,   -1,
  286,   -1,  288,  289,   -1,   -1,  292,   -1,  126,  283,
   -1,  285,  298,  299,   93,   -1,   -1,   -1,   -1,   33,
   -1,   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   43,
   -1,   45,  318,  319,  320,   -1,  257,   -1,   -1,   -1,
  326,   -1,  263,  264,   -1,  266,   -1,  126,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  279,   -1,
   -1,   -1,   -1,  284,   -1,  286,   -1,  288,  289,   -1,
   -1,  292,   -1,   -1,   -1,  257,   -1,  298,  299,   93,
   -1,  263,  264,   33,  266,   -1,   -1,   -1,   38,   -1,
   40,   -1,   42,   43,   -1,   45,   -1,  318,  319,  320,
   -1,   -1,  284,   -1,  286,  326,  288,  289,   -1,   -1,
  292,   -1,  126,   -1,   -1,   -1,  298,  299,   -1,   -1,
   -1,   -1,   33,   -1,   -1,   -1,   -1,   38,   -1,   40,
   -1,   42,   43,   -1,   45,   -1,  318,  319,  320,  257,
   -1,   -1,   -1,   -1,  326,  263,  264,   -1,  266,   -1,
  258,  259,  260,  261,  262,   -1,   -1,   -1,   -1,  267,
  268,  269,   -1,   -1,   -1,   -1,  284,   -1,  286,   -1,
  288,  289,   -1,   -1,  292,  283,  126,  285,  257,   -1,
  298,  299,   -1,   -1,  263,  264,   33,  266,   -1,   -1,
   -1,   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,
  318,  319,  320,   -1,   -1,  284,   -1,  286,  326,  288,
  289,   -1,   -1,  292,   -1,  126,   -1,   -1,   -1,  298,
  299,   -1,   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,
   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,  318,
  319,  320,   -1,  257,   -1,   -1,   -1,  326,   -1,  263,
  264,   41,  266,   -1,   44,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
  284,   61,  286,   63,  288,  289,   -1,   -1,  292,  126,
   -1,   -1,   -1,   -1,  298,  299,   -1,   -1,   -1,   33,
   -1,   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   43,
   -1,   45,   -1,   93,  318,  319,  320,  257,   -1,   -1,
   44,   -1,  326,  263,  264,   -1,  266,   -1,  126,   -1,
   -1,   -1,   -1,   -1,   -1,   59,   -1,   61,   -1,   -1,
   -1,   -1,   -1,   -1,  284,  125,  286,   -1,  288,  289,
   -1,   -1,  292,   40,   41,   42,  257,   44,  298,  299,
   -1,   -1,  263,  264,   33,  266,   -1,   -1,   -1,   38,
   -1,   40,   59,   42,   43,   -1,   45,   -1,  318,  319,
  320,   -1,   -1,  284,   -1,  286,  326,  288,  289,   -1,
   -1,  292,  126,   -1,   -1,   -1,   -1,  298,  299,  123,
   -1,   -1,   -1,   33,   91,   -1,   -1,   -1,   38,   -1,
   40,   -1,   42,   43,   -1,   45,   -1,  318,  319,  320,
  257,   -1,   -1,   -1,   -1,  326,  263,  264,   -1,  266,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  284,   -1,  286,
   -1,  288,  289,   -1,   -1,  292,   -1,  126,   -1,  257,
   -1,  298,  299,   -1,   -1,  263,  264,   33,  266,   -1,
   -1,   -1,   38,   -1,   40,   -1,   42,   43,   -1,   45,
   -1,  318,  319,  320,   -1,  265,  284,   -1,  286,  326,
  288,  289,   -1,   -1,  292,   -1,  126,   -1,   -1,   -1,
  298,  299,   -1,   -1,   -1,  285,   -1,   -1,   -1,   -1,
  290,  291,  292,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  318,  319,  320,  257,   -1,   -1,   -1,   -1,  326,  263,
  264,   -1,  266,   -1,  258,  259,  260,  261,  262,   -1,
   -1,   -1,   -1,  267,  268,  269,   -1,   -1,   -1,   -1,
  284,   -1,  286,   -1,  288,  289,   -1,   -1,  292,  283,
  126,  285,   -1,   -1,  298,  299,   -1,   -1,   -1,   -1,
  257,  258,  259,  260,  261,  262,   -1,   -1,   -1,   -1,
  267,  268,  269,   -1,  318,  319,  320,   -1,  257,   -1,
   -1,   -1,  326,   -1,  263,  264,  283,  266,   37,   38,
   -1,   40,   -1,   42,   43,   -1,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,   -1,  284,   -1,  286,   -1,  288,
  289,   -1,   61,  292,   63,   -1,   -1,  257,   -1,  298,
  299,   -1,   -1,  263,  264,   -1,  266,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  318,
  319,  320,   91,   -1,  284,   94,  286,  326,  288,  289,
   -1,   38,  292,   -1,   41,   -1,   -1,   44,  298,  299,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   -1,   61,  124,   63,   -1,  318,  319,
  320,  257,   -1,   -1,   -1,   -1,  326,  263,  264,   -1,
  266,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   41,   42,   -1,   44,   -1,   -1,   93,   94,  284,   -1,
  286,   -1,  288,  289,   -1,   -1,  292,   58,   59,   -1,
   -1,   -1,  298,  299,   -1,   37,   38,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,   -1,  124,  125,   -1,
   -1,   -1,  318,  319,  320,   -1,   58,   59,   -1,   61,
  326,   63,   37,   38,   -1,   40,   -1,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   -1,   61,   -1,   63,   91,
   -1,   93,   94,   -1,  125,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,   38,   -1,
   -1,   41,   42,   43,   44,   45,   91,   47,   -1,   94,
   -1,   -1,  124,  125,   -1,   -1,   -1,   -1,   58,   59,
   -1,   61,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,
  125,  290,  291,  292,  293,  294,  295,  296,   -1,  298,
  299,   -1,  301,   93,   94,   37,   38,   -1,   -1,   -1,
   42,   43,   -1,   45,   -1,   47,   -1,   37,   38,   -1,
   -1,   -1,   42,   43,   -1,   45,   -1,   47,  265,   61,
   -1,   63,   -1,   -1,  124,  125,   -1,   -1,   58,   37,
   38,   61,   -1,   63,   42,   43,   -1,   45,  285,   47,
   -1,   -1,   -1,  290,  291,  292,  293,  294,  295,  296,
   -1,   93,   94,   61,   -1,   63,  257,  258,  259,  260,
  261,  262,   -1,   -1,   94,   -1,  267,  268,  269,   -1,
   -1,   -1,   -1,   -1,   -1,   37,   38,   -1,   -1,   -1,
   42,   43,  124,   45,  285,   47,   94,   -1,   -1,   -1,
   -1,   -1,   -1,  265,  124,   -1,   -1,   -1,   -1,   61,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  285,   -1,   -1,  124,   -1,  290,  291,
  292,  293,  294,  295,  296,   -1,  298,  299,   -1,  301,
   -1,   93,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  290,  291,  292,  293,  294,
  295,  296,   -1,  298,  299,   -1,  301,   -1,   37,   38,
   -1,   -1,  124,   42,   43,  265,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   -1,   -1,   61,   -1,   63,  285,   -1,   -1,   -1,   -1,
  290,  291,  292,  293,  294,  295,  296,   -1,   -1,   -1,
   -1,   -1,   37,   38,   -1,   -1,   -1,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  265,   -1,   -1,   61,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   -1,  265,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  124,   -1,   -1,  290,  291,
  292,  293,  294,  295,  296,   -1,   -1,   -1,   -1,   94,
  290,  291,  292,  293,  294,  295,  296,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  285,   -1,   -1,
   -1,   -1,  290,  291,  292,  293,  294,  295,  296,  124,
   38,   -1,   -1,   41,   -1,   43,   44,   45,   -1,   -1,
   -1,   -1,   38,   -1,   -1,   41,   -1,   43,   44,   45,
   58,   59,   -1,   61,   -1,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   -1,   61,   -1,   63,  290,  291,
  292,  293,  294,  295,  296,   -1,   -1,   -1,   -1,   -1,
   -1,   38,   -1,   -1,   41,   93,   94,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   94,   -1,
   -1,   58,   59,   -1,   61,   -1,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  124,  125,   38,   -1,
   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,  124,  125,
   -1,   40,   41,   42,   -1,   44,   93,   94,   58,   59,
   -1,   61,   -1,   63,   -1,   -1,   -1,   -1,   -1,   58,
   59,  290,  291,  292,  293,  294,  295,  296,   38,   -1,
   -1,   41,   -1,   -1,   44,   -1,   -1,  124,  125,   41,
   -1,   -1,   44,   93,   94,   -1,   -1,   -1,   58,   59,
   -1,   61,   -1,   63,   -1,   -1,   58,   59,   -1,   61,
   -1,   63,   -1,   -1,   -1,  290,  291,  292,  293,  294,
  295,  296,   -1,   -1,  124,  125,   -1,   40,   41,   42,
   -1,   44,   -1,   93,   94,   -1,  125,   -1,   -1,   -1,
   -1,   93,   94,   -1,   -1,   58,   59,   -1,   40,   41,
   42,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  124,  125,   58,   59,   -1,   -1,
   -1,   -1,  124,  125,   -1,   -1,   -1,  265,   91,   40,
   41,   42,   -1,   44,   -1,   -1,   -1,   -1,   -1,  265,
   -1,   -1,   40,   41,   42,   -1,   44,  285,   59,   91,
   -1,   -1,  290,  291,  292,  293,  294,  295,  296,  285,
   58,   59,  125,   -1,  290,  291,  292,  293,  294,  295,
  296,   -1,   -1,   40,   41,   42,   -1,   44,  265,   -1,
   91,   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   91,   41,   -1,   -1,   44,  285,   -1,
   -1,   -1,   -1,  290,  291,  292,  293,  294,   -1,   -1,
   -1,   58,   59,   -1,   61,  265,   -1,   -1,  257,  258,
  259,  260,  261,  262,   91,   -1,   -1,  125,  267,  268,
  269,   -1,   -1,   -1,   -1,  285,   -1,   -1,   -1,   -1,
  290,  291,  292,  293,  283,   -1,  285,   41,   -1,   -1,
   44,   -1,   -1,   -1,   -1,  265,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  265,   58,   59,   -1,   61,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  285,  123,   -1,  125,   -1,
  290,  291,  292,  285,   -1,   -1,   -1,   -1,  290,  291,
  292,   -1,   -1,   -1,  257,  258,  259,  260,  261,  262,
   -1,   -1,   -1,   -1,  267,  268,  269,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,  261,
  262,   41,  285,   -1,   44,  267,  268,  269,   -1,  123,
   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   -1,   61,   -1,  285,   -1,   -1,  257,  258,   -1,  260,
   -1,   -1,   -1,   -1,   -1,   -1,  267,  268,  269,  257,
  258,  259,  260,  261,  262,   41,   -1,   -1,   44,  267,
  268,  269,  283,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   44,   -1,   58,   59,   -1,   61,   -1,  285,   -1,   -1,
  257,  258,   -1,  260,   -1,   59,   -1,   61,   -1,   -1,
  267,  268,  269,  123,   -1,  125,   40,   41,   42,  256,
   44,  258,  259,  260,  261,  262,  283,   -1,  285,   -1,
  267,  268,  269,   -1,   -1,   59,   -1,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  282,  283,   -1,  285,   -1,
   -1,   58,   59,   -1,   61,   -1,   44,  123,   -1,  125,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,  123,
   58,   59,  256,   61,  258,  259,  260,  261,  262,   -1,
   -1,   -1,   -1,  267,  268,  269,   -1,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  282,  283,
   -1,  285,   59,   -1,   61,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  123,   -1,  125,   44,
   -1,   59,   -1,   61,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,  123,   61,  125,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,  258,  259,
  260,  261,  262,   -1,   -1,   -1,   -1,  267,  268,  269,
   -1,   40,   41,   42,   -1,   44,  123,   -1,   -1,   -1,
   -1,   -1,  282,  283,   -1,  285,   -1,   -1,   -1,   58,
   59,   -1,   -1,   -1,   -1,  123,   -1,   -1,   -1,   -1,
  256,   -1,  258,  259,  260,  261,  262,   59,  123,   -1,
   -1,  267,  268,  269,  258,  259,  260,  261,  262,   -1,
   -1,   -1,   91,  267,  268,  269,  282,  283,   -1,  285,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  283,
   -1,  285,   -1,  257,  258,  259,  260,  261,  262,   -1,
   -1,   -1,   -1,  267,  268,  269,  125,   -1,   -1,  256,
   -1,  258,  259,  260,  261,  262,   -1,   -1,   -1,  283,
  267,  268,  269,   40,   41,   42,   -1,   44,  256,   -1,
  258,  259,  260,  261,  262,  282,  283,   -1,  285,  267,
  268,  269,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  282,  283,   -1,  285,   -1,  256,
   -1,  258,  259,  260,  261,  262,   -1,   -1,   -1,   -1,
  267,  268,  269,   -1,   91,   -1,   -1,   -1,  256,   -1,
  258,  259,  260,  261,  262,   -1,  283,   -1,  285,  267,
  268,  269,   -1,  258,  259,  260,  261,  262,   -1,   -1,
   -1,   -1,  267,  268,  269,  283,   -1,  285,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  283,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,  260,  261,  262,   -1,   -1,   -1,   -1,  267,  268,
  269,   -1,   -1,   -1,  256,   -1,  258,  259,  260,  261,
  262,   -1,   -1,   -1,   -1,  267,  268,  269,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  282,  283,   -1,  285,  286,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,  258,  259,  260,  261,  262,   -1,   -1,   -1,   -1,
  267,  268,  269,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 326
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,0,"'%'","'&'",0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,
0,0,0,0,0,0,0,"':'","';'",0,"'='",0,"'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,"'['",0,"']'","'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'{'","'|'","'}'","'~'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"IDENTIFIER","TYPENAME",
"SCSPEC","TYPESPEC","TYPE_QUAL","TYPE_QUAL_S","CONSTANT","STRING","ELLIPSIS",
"SIZEOF","ENUM","STRUCT","UNION","IF","ELSE","WHILE","DO","FOR","SWITCH","CASE",
"DEFAULT","BREAK","CONTINUE","RETURN","GOTO","ASM_KEYWORD","TYPEOF","ALIGNOF",
"ATTRIBUTE","EXTENSION","LABEL","REALPART","IMAGPART","ASSIGN","OROR","ANDAND",
"EQCOMPARE","ARITHCOMPARE","LSHIFT","RSHIFT","UNARY","PLUSPLUS","MINUSMINUS",
"HYPERUNARY","POINTSAT","INTERFACE","IMPLEMENTATION","END","SELECTOR","DEFS",
"ENCODE","CLASSNAME","PUBLIC","PRIVATE","PROTECTED","PROTOCOL","OBJECTNAME",
"CLASS","ALIAS","OBJC_STRING","FORALL","UPC_BLOCKSIZEOF","UPC_LOCALSIZEOF",
"UPC_ELEMSIZEOF","UPC_BARRIER","UPC_NOTIFY","UPC_WAIT","END_OF_LINE",
"UPC_FENCE","BUPC_ASSERT_TYPE",
};
const char * const yyrule[] = {
"$accept : program",
"program :",
"program : extdefs",
"$$1 :",
"extdefs : $$1 extdef",
"$$2 :",
"extdefs : extdefs $$2 extdef",
"extdef : fndef",
"extdef : datadef",
"extdef : ASM_KEYWORD '(' expr ')' ';'",
"extdef : extension extdef",
"datadef : setspecs notype_initdecls ';'",
"datadef : declmods setspecs notype_initdecls ';'",
"datadef : typed_declspecs setspecs initdecls ';'",
"datadef : declmods ';'",
"datadef : typed_declspecs ';'",
"datadef : error ';'",
"datadef : error '}'",
"datadef : ';'",
"$$3 :",
"$$4 :",
"fndef : typed_declspecs setspecs declarator $$3 old_style_parm_decls $$4 compstmt_or_error",
"fndef : typed_declspecs setspecs declarator error",
"$$5 :",
"$$6 :",
"fndef : declmods setspecs notype_declarator $$5 old_style_parm_decls $$6 compstmt_or_error",
"fndef : declmods setspecs notype_declarator error",
"$$7 :",
"$$8 :",
"fndef : setspecs notype_declarator $$7 old_style_parm_decls $$8 compstmt_or_error",
"fndef : setspecs notype_declarator error",
"identifier : IDENTIFIER",
"identifier : TYPENAME",
"unop : '&'",
"unop : '-'",
"unop : '+'",
"unop : PLUSPLUS",
"unop : MINUSMINUS",
"unop : '~'",
"unop : '!'",
"expr : nonnull_exprlist",
"exprlist :",
"exprlist : nonnull_exprlist",
"nonnull_exprlist : expr_no_commas",
"nonnull_exprlist : nonnull_exprlist ',' expr_no_commas",
"unary_expr : primary",
"unary_expr : '*' cast_expr",
"unary_expr : extension cast_expr",
"unary_expr : unop cast_expr",
"unary_expr : ANDAND identifier",
"unary_expr : sizeof unary_expr",
"unary_expr : sizeof '(' typename ')'",
"unary_expr : upc_blocksizeof unary_expr",
"unary_expr : upc_blocksizeof '(' typename ')'",
"unary_expr : upc_localsizeof unary_expr",
"unary_expr : upc_localsizeof '(' typename ')'",
"unary_expr : upc_elemsizeof unary_expr",
"unary_expr : upc_elemsizeof '(' typename ')'",
"unary_expr : alignof unary_expr",
"unary_expr : alignof '(' typename ')'",
"unary_expr : REALPART cast_expr",
"unary_expr : IMAGPART cast_expr",
"upc_blocksizeof : UPC_BLOCKSIZEOF",
"upc_localsizeof : UPC_LOCALSIZEOF",
"upc_elemsizeof : UPC_ELEMSIZEOF",
"bupc_assert_type : BUPC_ASSERT_TYPE",
"sizeof : SIZEOF",
"alignof : ALIGNOF",
"cast_expr : unary_expr",
"cast_expr : '(' typename ')' cast_expr",
"$$9 :",
"cast_expr : '(' typename ')' '{' $$9 initlist_maybe_comma '}'",
"expr_no_commas : cast_expr",
"expr_no_commas : expr_no_commas '+' expr_no_commas",
"expr_no_commas : expr_no_commas '-' expr_no_commas",
"expr_no_commas : expr_no_commas '*' expr_no_commas",
"expr_no_commas : expr_no_commas '/' expr_no_commas",
"expr_no_commas : expr_no_commas '%' expr_no_commas",
"expr_no_commas : expr_no_commas LSHIFT expr_no_commas",
"expr_no_commas : expr_no_commas RSHIFT expr_no_commas",
"expr_no_commas : expr_no_commas ARITHCOMPARE expr_no_commas",
"expr_no_commas : expr_no_commas EQCOMPARE expr_no_commas",
"expr_no_commas : expr_no_commas '&' expr_no_commas",
"expr_no_commas : expr_no_commas '|' expr_no_commas",
"expr_no_commas : expr_no_commas '^' expr_no_commas",
"$$10 :",
"expr_no_commas : expr_no_commas ANDAND $$10 expr_no_commas",
"$$11 :",
"expr_no_commas : expr_no_commas OROR $$11 expr_no_commas",
"$$12 :",
"$$13 :",
"expr_no_commas : expr_no_commas '?' $$12 expr ':' $$13 expr_no_commas",
"$$14 :",
"expr_no_commas : expr_no_commas '?' $$14 ':' expr_no_commas",
"expr_no_commas : expr_no_commas '=' expr_no_commas",
"expr_no_commas : expr_no_commas ASSIGN expr_no_commas",
"primary : IDENTIFIER",
"primary : CONSTANT",
"primary : string",
"primary : '(' expr ')'",
"primary : '(' error ')'",
"$$15 :",
"primary : '(' $$15 compstmt ')'",
"primary : bupc_assert_type '(' typename ',' typename ')'",
"primary : bupc_assert_type '(' typename ',' unary_expr ')'",
"primary : bupc_assert_type '(' unary_expr ',' typename ')'",
"primary : bupc_assert_type '(' unary_expr ',' unary_expr ')'",
"primary : primary '(' exprlist ')'",
"primary : primary '[' expr ']'",
"primary : primary '.' identifier",
"primary : primary POINTSAT identifier",
"primary : primary PLUSPLUS",
"primary : primary MINUSMINUS",
"string : STRING",
"string : string STRING",
"old_style_parm_decls :",
"old_style_parm_decls : datadecls",
"old_style_parm_decls : datadecls ELLIPSIS",
"lineno_datadecl : save_filename save_lineno datadecl",
"datadecls : lineno_datadecl",
"datadecls : errstmt",
"datadecls : datadecls lineno_datadecl",
"datadecls : lineno_datadecl errstmt",
"datadecl : typed_declspecs_no_prefix_attr setspecs initdecls ';'",
"datadecl : declmods_no_prefix_attr setspecs notype_initdecls ';'",
"datadecl : typed_declspecs_no_prefix_attr ';'",
"datadecl : declmods_no_prefix_attr ';'",
"setspecs :",
"setattrs :",
"decl : typed_declspecs setspecs initdecls ';'",
"decl : declmods setspecs notype_initdecls ';'",
"decl : typed_declspecs setspecs nested_function",
"decl : declmods setspecs notype_nested_function",
"decl : typed_declspecs ';'",
"decl : declmods ';'",
"decl : extension decl",
"typed_declspecs : typespec reserved_declspecs",
"typed_declspecs : declmods typespec reserved_declspecs",
"reserved_declspecs :",
"reserved_declspecs : reserved_declspecs typespecqual_reserved",
"reserved_declspecs : reserved_declspecs SCSPEC",
"reserved_declspecs : reserved_declspecs attributes",
"typed_declspecs_no_prefix_attr : typespec reserved_declspecs_no_prefix_attr",
"typed_declspecs_no_prefix_attr : declmods_no_prefix_attr typespec reserved_declspecs_no_prefix_attr",
"reserved_declspecs_no_prefix_attr :",
"reserved_declspecs_no_prefix_attr : reserved_declspecs_no_prefix_attr typespecqual_reserved",
"reserved_declspecs_no_prefix_attr : reserved_declspecs_no_prefix_attr SCSPEC",
"declmods : declmods_no_prefix_attr",
"declmods : attributes",
"declmods : declmods declmods_no_prefix_attr",
"declmods : declmods attributes",
"declmods_no_prefix_attr : type_qualifier",
"declmods_no_prefix_attr : SCSPEC",
"declmods_no_prefix_attr : declmods_no_prefix_attr type_qualifier",
"declmods_no_prefix_attr : declmods_no_prefix_attr SCSPEC",
"type_qualifier : TYPE_QUAL",
"type_qualifier : TYPE_QUAL_S",
"type_qualifier : TYPE_QUAL_S layout_specifier",
"typed_typespecs : typespec reserved_typespecquals",
"typed_typespecs : nonempty_type_quals typespec reserved_typespecquals",
"layout_specifier : '[' xexpr ']'",
"reserved_typespecquals :",
"reserved_typespecquals : reserved_typespecquals typespecqual_reserved",
"typespec : TYPESPEC",
"typespec : structsp",
"typespec : TYPENAME",
"typespec : TYPEOF '(' expr ')'",
"typespec : TYPEOF '(' typename ')'",
"typespecqual_reserved : TYPESPEC",
"typespecqual_reserved : TYPE_QUAL",
"typespecqual_reserved : TYPE_QUAL_S",
"typespecqual_reserved : TYPE_QUAL_S layout_specifier",
"typespecqual_reserved : structsp",
"initdecls : initdcl",
"initdecls : initdecls ',' initdcl",
"notype_initdecls : notype_initdcl",
"notype_initdecls : notype_initdecls ',' initdcl",
"maybeasm :",
"maybeasm : ASM_KEYWORD '(' string ')'",
"$$16 :",
"initdcl : declarator maybeasm maybe_attribute '=' $$16 init",
"initdcl : declarator maybeasm maybe_attribute",
"$$17 :",
"notype_initdcl : notype_declarator maybeasm maybe_attribute '=' $$17 init",
"notype_initdcl : notype_declarator maybeasm maybe_attribute",
"maybe_attribute :",
"maybe_attribute : attributes",
"attributes : attribute",
"attributes : attributes attribute",
"attribute : ATTRIBUTE '(' '(' attribute_list ')' ')'",
"attribute_list : attrib",
"attribute_list : attribute_list ',' attrib",
"attrib :",
"attrib : any_word",
"attrib : any_word '(' IDENTIFIER ')'",
"attrib : any_word '(' IDENTIFIER ',' nonnull_exprlist ')'",
"attrib : any_word '(' exprlist ')'",
"any_word : identifier",
"any_word : SCSPEC",
"any_word : TYPESPEC",
"any_word : TYPE_QUAL",
"any_word : TYPE_QUAL_S",
"init : expr_no_commas",
"$$18 :",
"init : '{' $$18 initlist_maybe_comma '}'",
"init : error",
"initlist_maybe_comma :",
"initlist_maybe_comma : initlist1 maybecomma",
"initlist1 : initelt",
"initlist1 : initlist1 ',' initelt",
"initelt : designator_list '=' initval",
"initelt : designator initval",
"$$19 :",
"initelt : identifier ':' $$19 initval",
"initelt : initval",
"$$20 :",
"initval : '{' $$20 initlist_maybe_comma '}'",
"initval : expr_no_commas",
"initval : error",
"designator_list : designator",
"designator_list : designator_list designator",
"designator : '.' identifier",
"designator : '[' expr_no_commas ELLIPSIS expr_no_commas ']'",
"designator : '[' expr_no_commas ']'",
"$$21 :",
"$$22 :",
"nested_function : declarator $$21 old_style_parm_decls $$22 compstmt",
"$$23 :",
"$$24 :",
"notype_nested_function : notype_declarator $$23 old_style_parm_decls $$24 compstmt",
"declarator : after_type_declarator",
"declarator : notype_declarator",
"after_type_declarator : '(' after_type_declarator ')'",
"after_type_declarator : after_type_declarator '(' parmlist_or_identifiers",
"after_type_declarator : after_type_declarator '[' expr ']'",
"after_type_declarator : after_type_declarator '[' ']'",
"after_type_declarator : '*' type_quals after_type_declarator",
"after_type_declarator : attributes setattrs after_type_declarator",
"after_type_declarator : TYPENAME",
"maybe_type_qualifier_list :",
"maybe_type_qualifier_list : SCSPEC type_qualifier_list",
"maybe_type_qualifier_list : type_qualifier_list SCSPEC",
"maybe_type_qualifier_list : type_qualifier_list",
"type_qualifier_list : TYPE_QUAL",
"type_qualifier_list : type_qualifier_list TYPE_QUAL",
"parm_declarator : parm_declarator '(' parmlist_or_identifiers",
"parm_declarator : parm_declarator '[' maybe_type_qualifier_list '*' ']'",
"parm_declarator : parm_declarator '[' maybe_type_qualifier_list expr ']'",
"parm_declarator : parm_declarator '[' maybe_type_qualifier_list ']'",
"parm_declarator : '*' type_quals parm_declarator",
"parm_declarator : attributes setattrs parm_declarator",
"parm_declarator : TYPENAME",
"notype_declarator : notype_declarator '(' parmlist_or_identifiers",
"notype_declarator : '(' notype_declarator ')'",
"notype_declarator : '*' type_quals notype_declarator",
"notype_declarator : notype_declarator '[' maybe_type_qualifier_list '*' ']'",
"notype_declarator : notype_declarator '[' maybe_type_qualifier_list expr ']'",
"notype_declarator : notype_declarator '[' maybe_type_qualifier_list ']'",
"notype_declarator : attributes setattrs notype_declarator",
"notype_declarator : IDENTIFIER",
"struct_head : STRUCT",
"struct_head : STRUCT attributes",
"union_head : UNION",
"union_head : UNION attributes",
"enum_head : ENUM",
"enum_head : ENUM attributes",
"$$25 :",
"structsp : struct_head identifier '{' $$25 component_decl_list '}' maybe_attribute",
"structsp : struct_head '{' component_decl_list '}' maybe_attribute",
"structsp : struct_head identifier",
"$$26 :",
"structsp : union_head identifier '{' $$26 component_decl_list '}' maybe_attribute",
"structsp : union_head '{' component_decl_list '}' maybe_attribute",
"structsp : union_head identifier",
"$$27 :",
"structsp : enum_head identifier '{' $$27 enumlist maybecomma_warn '}' maybe_attribute",
"$$28 :",
"structsp : enum_head '{' $$28 enumlist maybecomma_warn '}' maybe_attribute",
"structsp : enum_head identifier",
"maybecomma :",
"maybecomma : ','",
"maybecomma_warn :",
"maybecomma_warn : ','",
"component_decl_list : component_decl_list2",
"component_decl_list : component_decl_list2 component_decl",
"component_decl_list2 :",
"component_decl_list2 : component_decl_list2 component_decl ';'",
"component_decl_list2 : component_decl_list2 ';'",
"component_decl : typed_typespecs setspecs components",
"component_decl : typed_typespecs",
"component_decl : nonempty_type_quals setspecs components",
"component_decl : nonempty_type_quals",
"component_decl : error",
"component_decl : extension component_decl",
"components : component_declarator",
"components : components ',' component_declarator",
"component_declarator : save_filename save_lineno declarator maybe_attribute",
"component_declarator : save_filename save_lineno declarator ':' expr_no_commas maybe_attribute",
"component_declarator : save_filename save_lineno ':' expr_no_commas maybe_attribute",
"enumlist : enumerator",
"enumlist : enumlist ',' enumerator",
"enumlist : error",
"enumerator : identifier",
"enumerator : identifier '=' expr_no_commas",
"typename : typed_typespecs absdcl",
"typename : nonempty_type_quals absdcl",
"absdcl :",
"absdcl : absdcl1",
"nonempty_type_quals : type_qualifier",
"nonempty_type_quals : nonempty_type_quals type_qualifier",
"type_quals :",
"type_quals : type_quals type_qualifier",
"absdcl1 : '(' absdcl1 ')'",
"absdcl1 : '*' type_quals absdcl1",
"absdcl1 : '*' type_quals",
"absdcl1 : absdcl1 '(' parmlist",
"absdcl1 : absdcl1 '[' maybe_type_qualifier_list expr ']'",
"absdcl1 : absdcl1 '[' maybe_type_qualifier_list ']'",
"absdcl1 : '(' parmlist",
"absdcl1 : '[' maybe_type_qualifier_list expr ']'",
"absdcl1 : '[' maybe_type_qualifier_list ']'",
"absdcl1 : attributes setattrs absdcl1",
"stmts : lineno_stmt_or_labels",
"lineno_stmt_or_labels : lineno_stmt_or_label",
"lineno_stmt_or_labels : lineno_stmt_or_labels lineno_stmt_or_label",
"lineno_stmt_or_labels : lineno_stmt_or_labels errstmt",
"errstmt : error ';'",
"pushlevel :",
"maybe_label_decls :",
"maybe_label_decls : label_decls",
"label_decls : label_decl",
"label_decls : label_decls label_decl",
"label_decl : LABEL identifiers_or_typenames ';'",
"compstmt_or_error : compstmt",
"compstmt_or_error : error compstmt",
"compstmt_start : '{'",
"compstmt : compstmt_start '}'",
"compstmt : compstmt_start pushlevel maybe_label_decls error '}'",
"compstmt : compstmt_start pushlevel maybe_label_decls stmts '}'",
"simple_if : if_prefix lineno_labeled_stmt",
"simple_if : if_prefix error",
"if_prefix : IF '(' expr ')'",
"$$29 :",
"do_stmt_start : DO $$29 lineno_labeled_stmt WHILE",
"save_filename :",
"save_lineno :",
"lineno_labeled_stmt : save_filename save_lineno stmt",
"lineno_labeled_stmt : save_filename save_lineno label lineno_labeled_stmt",
"lineno_stmt_or_label : save_filename save_lineno stmt_or_label",
"stmt_or_label : stmt",
"stmt_or_label : label",
"stmt_or_label : decl",
"stmt : compstmt",
"stmt : all_iter_stmt",
"stmt : expr ';'",
"$$30 :",
"stmt : simple_if ELSE $$30 lineno_labeled_stmt",
"stmt : simple_if",
"stmt : simple_if ELSE error",
"$$31 :",
"$$32 :",
"stmt : WHILE $$31 '(' expr ')' $$32 lineno_labeled_stmt",
"stmt : do_stmt_start '(' expr ')' ';'",
"stmt : do_stmt_start error",
"$$33 :",
"$$34 :",
"$$35 :",
"stmt : FOR '(' for_init_stmt $$33 xexpr ';' $$34 xexpr ')' $$35 lineno_labeled_stmt",
"$$36 :",
"$$37 :",
"$$38 :",
"$$39 :",
"stmt : FORALL '(' for_init_stmt $$36 xexpr ';' $$37 xexpr ';' $$38 affinity_expr ')' $$39 lineno_labeled_stmt",
"$$40 :",
"stmt : SWITCH '(' expr ')' $$40 lineno_labeled_stmt",
"stmt : BREAK ';'",
"stmt : CONTINUE ';'",
"stmt : RETURN ';'",
"stmt : RETURN expr ';'",
"stmt : UPC_NOTIFY ';'",
"stmt : UPC_FENCE ';'",
"stmt : UPC_NOTIFY expr ';'",
"stmt : UPC_WAIT ';'",
"stmt : UPC_WAIT expr ';'",
"stmt : UPC_BARRIER ';'",
"stmt : UPC_BARRIER expr ';'",
"stmt : ASM_KEYWORD maybe_type_qual '(' expr ')' ';'",
"stmt : ASM_KEYWORD maybe_type_qual '(' expr ':' asm_operands ')' ';'",
"stmt : ASM_KEYWORD maybe_type_qual '(' expr ':' asm_operands ':' asm_operands ')' ';'",
"stmt : ASM_KEYWORD maybe_type_qual '(' expr ':' asm_operands ':' asm_operands ':' asm_clobbers ')' ';'",
"stmt : GOTO identifier ';'",
"stmt : GOTO '*' expr ';'",
"stmt : ';'",
"for_pushlevel :",
"for_init_stmt : xexpr ';'",
"for_init_stmt : for_pushlevel lineno_datadecl",
"affinity_expr : xexpr",
"affinity_expr : CONTINUE",
"all_iter_stmt : all_iter_stmt_simple",
"$$41 :",
"all_iter_stmt_simple : FOR '(' primary ')' $$41 lineno_labeled_stmt",
"label : CASE expr_no_commas ':'",
"label : CASE expr_no_commas ELLIPSIS expr_no_commas ':'",
"label : DEFAULT ':'",
"label : identifier ':' maybe_attribute",
"maybe_type_qual :",
"maybe_type_qual : TYPE_QUAL",
"xexpr :",
"xexpr : expr",
"xexpr : '*'",
"asm_operands :",
"asm_operands : nonnull_asm_operands",
"nonnull_asm_operands : asm_operand",
"nonnull_asm_operands : nonnull_asm_operands ',' asm_operand",
"asm_operand : STRING '(' expr ')'",
"asm_clobbers : string",
"asm_clobbers : asm_clobbers ',' string",
"$$42 :",
"parmlist : $$42 parmlist_1",
"parmlist_1 : parmlist_2 ')'",
"$$43 :",
"parmlist_1 : parms ';' $$43 parmlist_1",
"parmlist_1 : error ')'",
"parmlist_2 :",
"parmlist_2 : ELLIPSIS",
"parmlist_2 : parms",
"parmlist_2 : parms ',' ELLIPSIS",
"parms : parm",
"parms : parms ',' parm",
"parm : typed_declspecs setspecs parm_declarator maybe_attribute",
"parm : typed_declspecs setspecs notype_declarator maybe_attribute",
"parm : typed_declspecs setspecs absdcl maybe_attribute",
"parm : declmods setspecs notype_declarator maybe_attribute",
"parm : declmods setspecs absdcl maybe_attribute",
"$$44 :",
"parmlist_or_identifiers : $$44 parmlist_or_identifiers_1",
"parmlist_or_identifiers_1 : parmlist_1",
"parmlist_or_identifiers_1 : identifiers ')'",
"identifiers : IDENTIFIER",
"identifiers : identifiers ',' IDENTIFIER",
"identifiers_or_typenames : identifier",
"identifiers_or_typenames : identifiers_or_typenames ',' identifier",
"extension : EXTENSION",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 276 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids an empty source file");
		  finish_file ();
		}
break;
case 2:
#line 281 "c-parse.y"
{
		  /* In case there were missing closebraces,
		     get us back to the global binding level.  */
		  while (! global_bindings_p ())
		    poplevel (0, 0, 0);
		  finish_file ();
		}
break;
case 3:
#line 295 "c-parse.y"
{yyval.ttype = NULL_TREE; }
break;
case 5:
#line 296 "c-parse.y"
{yyval.ttype = NULL_TREE; }
break;
case 9:
#line 303 "c-parse.y"
{ STRIP_NOPS (yyvsp[-2].ttype);
		  if ((TREE_CODE (yyvsp[-2].ttype) == ADDR_EXPR
		       && TREE_CODE (TREE_OPERAND (yyvsp[-2].ttype, 0)) == STRING_CST)
		      || TREE_CODE (yyvsp[-2].ttype) == STRING_CST)
		    assemble_asm (yyvsp[-2].ttype);
		  else
		    error ("argument of `asm' is not a constant string"); }
break;
case 10:
#line 311 "c-parse.y"
{ pedantic = yyvsp[-1].itype; }
break;
case 11:
#line 316 "c-parse.y"
{ if (pedantic)
		    error ("ANSI C forbids data definition with no type or storage class");
		  else if (!flag_traditional)
		    warning ("data definition has no type or storage class"); 

		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 12:
#line 326 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 13:
#line 331 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype);  }
break;
case 14:
#line 336 "c-parse.y"
{ pedwarn ("empty declaration"); }
break;
case 15:
#line 338 "c-parse.y"
{ shadow_tag (yyvsp[-1].ttype); }
break;
case 18:
#line 342 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C does not allow extra `;' outside of a function"); }
break;
case 19:
#line 348 "c-parse.y"
{ if (! start_function (current_declspecs, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    YYERROR1;
		  reinit_parse_for_function (); }
break;
case 20:
#line 353 "c-parse.y"
{ store_parm_decls (); }
break;
case 21:
#line 355 "c-parse.y"
{ finish_function (0); 
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-5].itype); }
break;
case 22:
#line 361 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 23:
#line 366 "c-parse.y"
{ if (! start_function (current_declspecs, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    YYERROR1;
		  reinit_parse_for_function (); }
break;
case 24:
#line 371 "c-parse.y"
{ store_parm_decls (); }
break;
case 25:
#line 373 "c-parse.y"
{ finish_function (0); 
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-5].itype); }
break;
case 26:
#line 379 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 27:
#line 384 "c-parse.y"
{ if (! start_function (NULL_TREE, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    YYERROR1;
		  reinit_parse_for_function (); }
break;
case 28:
#line 389 "c-parse.y"
{ store_parm_decls (); }
break;
case 29:
#line 391 "c-parse.y"
{ finish_function (0); 
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-5].itype); }
break;
case 30:
#line 397 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 33:
#line 409 "c-parse.y"
{ yyval.code = ADDR_EXPR; }
break;
case 34:
#line 411 "c-parse.y"
{ yyval.code = NEGATE_EXPR; }
break;
case 35:
#line 413 "c-parse.y"
{ yyval.code = CONVERT_EXPR; }
break;
case 36:
#line 415 "c-parse.y"
{ yyval.code = PREINCREMENT_EXPR; }
break;
case 37:
#line 417 "c-parse.y"
{ yyval.code = PREDECREMENT_EXPR; }
break;
case 38:
#line 419 "c-parse.y"
{ yyval.code = BIT_NOT_EXPR; }
break;
case 39:
#line 421 "c-parse.y"
{ yyval.code = TRUTH_NOT_EXPR; }
break;
case 40:
#line 425 "c-parse.y"
{ yyval.ttype = build_compound_expr (yyvsp[0].ttype); }
break;
case 41:
#line 430 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 43:
#line 436 "c-parse.y"
{ yyval.ttype = build_tree_list (NULL_TREE, yyvsp[0].ttype); }
break;
case 44:
#line 438 "c-parse.y"
{ chainon (yyvsp[-2].ttype, build_tree_list (NULL_TREE, yyvsp[0].ttype)); }
break;
case 46:
#line 444 "c-parse.y"
{ yyval.ttype = build_indirect_ref (yyvsp[0].ttype, "unary *"); }
break;
case 47:
#line 447 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  pedantic = yyvsp[-1].itype; }
break;
case 48:
#line 450 "c-parse.y"
{ yyval.ttype = build_unary_op (yyvsp[-1].code, yyvsp[0].ttype, 0);
		  overflow_warning (yyval.ttype); }
break;
case 49:
#line 454 "c-parse.y"
{ tree label = lookup_label (yyvsp[0].ttype);
		  if (pedantic)
		    pedwarn ("ANSI C forbids `&&'");
		  if (label == 0)
		    yyval.ttype = null_pointer_node;
		  else
		    {
		      TREE_USED (label) = 1;
		      yyval.ttype = build1 (ADDR_EXPR, ptr_type_node, label);
		      TREE_CONSTANT (yyval.ttype) = 1;
		    }
		}
break;
case 50:
#line 482 "c-parse.y"
{ skip_evaluation--;
		  if (TREE_CODE (yyvsp[0].ttype) == COMPONENT_REF
		      && DECL_C_BIT_FIELD (TREE_OPERAND (yyvsp[0].ttype, 1)))
		    error ("`sizeof' applied to a bit-field");
		  yyval.ttype = c_sizeof (TREE_TYPE (yyvsp[0].ttype)); }
break;
case 51:
#line 488 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = c_sizeof (groktypename (yyvsp[-1].ttype)); }
break;
case 52:
#line 492 "c-parse.y"
{ skip_evaluation--;
		  if (TREE_CODE (yyvsp[0].ttype) == COMPONENT_REF
		      && DECL_C_BIT_FIELD (TREE_OPERAND (yyvsp[0].ttype, 1)))
		    error ("`upc_blocksizeof' applied to a bit-field");
		  if (TREE_CODE (yyvsp[0].ttype) == ADDR_EXPR && 
		      TREE_CODE(TREE_OPERAND(yyvsp[0].ttype, 0)) == COMPONENT_REF) {
		    tree field_struct = TREE_OPERAND(TREE_OPERAND(yyvsp[0].ttype, 0), 0);
		    if (TYPE_SHARED(TREE_TYPE(field_struct))) {
		      yyval.ttype = integer_zero_node;
		    } else {
		      yyval.ttype = upc_blocksizeof(yyvsp[0].ttype);
		    }
		  } else {
		    yyval.ttype = upc_blocksizeof(yyvsp[0].ttype); 
		  }
		}
break;
case 53:
#line 509 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = upc_blocksizeof (groktypename (yyvsp[-1].ttype)); }
break;
case 54:
#line 512 "c-parse.y"
{ skip_evaluation--;
		  if (TREE_CODE (yyvsp[0].ttype) == COMPONENT_REF
		      && DECL_C_BIT_FIELD (TREE_OPERAND (yyvsp[0].ttype, 1)))
		    error ("`upc_localsizeof' applied to a bit-field");
		  yyval.ttype = upc_localsizeof (yyvsp[0].ttype); }
break;
case 55:
#line 518 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = upc_localsizeof (groktypename (yyvsp[-1].ttype)); }
break;
case 56:
#line 521 "c-parse.y"
{ skip_evaluation--;
		  if (TREE_CODE (yyvsp[0].ttype) == COMPONENT_REF
		      && DECL_C_BIT_FIELD (TREE_OPERAND (yyvsp[0].ttype, 1)))
		    error ("`upc_elemsizeof' applied to a bit-field");
		  yyval.ttype = upc_elemsizeof (TREE_TYPE (yyvsp[0].ttype)); }
break;
case 57:
#line 527 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = upc_elemsizeof (groktypename (yyvsp[-1].ttype)); }
break;
case 58:
#line 530 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = c_alignof_expr (yyvsp[0].ttype); }
break;
case 59:
#line 533 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = c_alignof (groktypename (yyvsp[-1].ttype)); }
break;
case 60:
#line 536 "c-parse.y"
{ yyval.ttype = build_unary_op (REALPART_EXPR, yyvsp[0].ttype, 0); }
break;
case 61:
#line 538 "c-parse.y"
{ yyval.ttype = build_unary_op (IMAGPART_EXPR, yyvsp[0].ttype, 0); }
break;
case 62:
#line 543 "c-parse.y"
{ skip_evaluation++; }
break;
case 63:
#line 546 "c-parse.y"
{ skip_evaluation++; }
break;
case 64:
#line 549 "c-parse.y"
{ skip_evaluation++; }
break;
case 65:
#line 552 "c-parse.y"
{skip_evaluation++; }
break;
case 66:
#line 555 "c-parse.y"
{ skip_evaluation++; }
break;
case 67:
#line 560 "c-parse.y"
{ skip_evaluation++; }
break;
case 69:
#line 566 "c-parse.y"
{ tree type = groktypename (yyvsp[-2].ttype);
		  yyval.ttype = build_c_cast (type, yyvsp[0].ttype); }
break;
case 70:
#line 569 "c-parse.y"
{ start_init (NULL_TREE, NULL, 0);
		  yyvsp[-2].ttype = groktypename (yyvsp[-2].ttype);
		  really_start_incremental_init (yyvsp[-2].ttype); }
break;
case 71:
#line 573 "c-parse.y"
{ char *name;
		  tree result = pop_init_level (0);
		  tree type = yyvsp[-5].ttype;
		  finish_init ();

		  if (pedantic && ! flag_isoc99)
		    pedwarn ("ANSI C forbids constructor expressions");
		  if (TYPE_NAME (type) != 0)
		    {
		      if (TREE_CODE (TYPE_NAME (type)) == IDENTIFIER_NODE)
			name = IDENTIFIER_POINTER (TYPE_NAME (type));
		      else
			name = IDENTIFIER_POINTER (DECL_NAME (TYPE_NAME (type)));
		    }
		  else
		    name = "";
		  yyval.ttype = result;
		  if (TREE_CODE (type) == ARRAY_TYPE && TYPE_SIZE (type) == 0)
		    {
		      int failure = complete_array_type (type, yyval.ttype, 1);
		      if (failure)
			abort ();
		    }
		}
break;
case 73:
#line 602 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 74:
#line 604 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 75:
#line 606 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 76:
#line 608 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 77:
#line 610 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 78:
#line 612 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 79:
#line 614 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 80:
#line 616 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 81:
#line 618 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 82:
#line 620 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 83:
#line 622 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 84:
#line 624 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 85:
#line 626 "c-parse.y"
{ yyvsp[-1].ttype = truthvalue_conversion (default_conversion (yyvsp[-1].ttype));
		  skip_evaluation += yyvsp[-1].ttype == boolean_false_node; }
break;
case 86:
#line 629 "c-parse.y"
{ skip_evaluation -= yyvsp[-3].ttype == boolean_false_node;
		  yyval.ttype = parser_build_binary_op (TRUTH_ANDIF_EXPR, yyvsp[-3].ttype, yyvsp[0].ttype); }
break;
case 87:
#line 632 "c-parse.y"
{ yyvsp[-1].ttype = truthvalue_conversion (default_conversion (yyvsp[-1].ttype));
		  skip_evaluation += yyvsp[-1].ttype == boolean_true_node; }
break;
case 88:
#line 635 "c-parse.y"
{ skip_evaluation -= yyvsp[-3].ttype == boolean_true_node;
		  yyval.ttype = parser_build_binary_op (TRUTH_ORIF_EXPR, yyvsp[-3].ttype, yyvsp[0].ttype); }
break;
case 89:
#line 638 "c-parse.y"
{ yyvsp[-1].ttype = truthvalue_conversion (default_conversion (yyvsp[-1].ttype));
		  skip_evaluation += yyvsp[-1].ttype == boolean_false_node; }
break;
case 90:
#line 641 "c-parse.y"
{ skip_evaluation += ((yyvsp[-4].ttype == boolean_true_node)
				      - (yyvsp[-4].ttype == boolean_false_node)); }
break;
case 91:
#line 644 "c-parse.y"
{ skip_evaluation -= yyvsp[-6].ttype == boolean_true_node;
		  yyval.ttype = build_conditional_expr (yyvsp[-6].ttype, yyvsp[-3].ttype, yyvsp[0].ttype); }
break;
case 92:
#line 647 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids omitting the middle term of a ?: expression");
		  /* Make sure first operand is calculated only once.  */
		  yyvsp[0].ttype = save_expr (yyvsp[-1].ttype);
		  yyvsp[-1].ttype = truthvalue_conversion (default_conversion (yyvsp[0].ttype));
		  skip_evaluation += yyvsp[-1].ttype == boolean_true_node; }
break;
case 93:
#line 654 "c-parse.y"
{ skip_evaluation -= yyvsp[-4].ttype == boolean_true_node;
		  yyval.ttype = build_conditional_expr (yyvsp[-4].ttype, yyvsp[-3].ttype, yyvsp[0].ttype); }
break;
case 94:
#line 657 "c-parse.y"
{ char class;
		  yyval.ttype = build_modify_expr (yyvsp[-2].ttype, NOP_EXPR, yyvsp[0].ttype);
		  class = TREE_CODE_CLASS (TREE_CODE (yyval.ttype));
		  if (class == 'e' || class == '1'
		      || class == '2' || class == '<')
		    C_SET_EXP_ORIGINAL_CODE (yyval.ttype, MODIFY_EXPR);
		}
break;
case 95:
#line 665 "c-parse.y"
{ char class;
		  yyval.ttype = build_modify_expr (yyvsp[-2].ttype, yyvsp[-1].code, yyvsp[0].ttype);
		  /* This inhibits warnings in truthvalue_conversion.  */
		  class = TREE_CODE_CLASS (TREE_CODE (yyval.ttype));
		  if (class == 'e' || class == '1'
		      || class == '2' || class == '<')
		    C_SET_EXP_ORIGINAL_CODE (yyval.ttype, ERROR_MARK);
		}
break;
case 96:
#line 677 "c-parse.y"
{
		  yyval.ttype = lastiddecl;
		  if (!yyval.ttype || yyval.ttype == error_mark_node)
		    {
		      if (yychar == YYEMPTY)
			yychar = YYLEX;
		      if (yychar == '(')
			{
			    {
			      /* Ordinary implicit function declaration.  */
			      yyval.ttype = implicitly_declare (yyvsp[0].ttype);
			      assemble_external (yyval.ttype);
			      TREE_USED (yyval.ttype) = 1;
			    }
			}
		      else if (current_function_decl == 0)
			{
			  error ("`%s' undeclared here (not in a function)",
				 IDENTIFIER_POINTER (yyvsp[0].ttype));
			  yyval.ttype = error_mark_node;
			}
		      else
			{
			    {
			      if (IDENTIFIER_GLOBAL_VALUE (yyvsp[0].ttype) != error_mark_node
				  || IDENTIFIER_ERROR_LOCUS (yyvsp[0].ttype) != current_function_decl)
				{
				  error ("`%s' undeclared (first use in this function)",
					 IDENTIFIER_POINTER (yyvsp[0].ttype));

				  if (! undeclared_variable_notice)
				    {
				      error ("(Each undeclared identifier is reported only once");
				      error ("for each function it appears in.)");
				      undeclared_variable_notice = 1;
				    }
				}
			      yyval.ttype = error_mark_node;
			      /* Prevent repeated error messages.  */
			      IDENTIFIER_GLOBAL_VALUE (yyvsp[0].ttype) = error_mark_node;
			      IDENTIFIER_ERROR_LOCUS (yyvsp[0].ttype) = current_function_decl;
			    }
			}
		    }
		  else if (TREE_TYPE (yyval.ttype) == error_mark_node)
		    yyval.ttype = error_mark_node;
		  else if (C_DECL_ANTICIPATED (yyval.ttype))
		    {
		      /* The first time we see a build-in function used,
			 if it has not been declared.  */
		      C_DECL_ANTICIPATED (yyval.ttype) = 0;
		      if (yychar == YYEMPTY)
			yychar = YYLEX;
		      if (yychar == '(')
			{
			  /* Omit the implicit declaration we
			     would ordinarily do, so we don't lose
			     the actual built in type.
			     But print a diagnostic for the mismatch.  */
			    if (TREE_CODE (yyval.ttype) != FUNCTION_DECL)
			      error ("`%s' implicitly declared as function",
				     IDENTIFIER_POINTER (DECL_NAME (yyval.ttype)));
			  else if ((TYPE_MODE (TREE_TYPE (TREE_TYPE (yyval.ttype)))
				    != TYPE_MODE (integer_type_node))
				   && (TREE_TYPE (TREE_TYPE (yyval.ttype))
				       != void_type_node))
			    pedwarn ("type mismatch in implicit declaration for built-in function `%s'",
				     IDENTIFIER_POINTER (DECL_NAME (yyval.ttype)));
			  /* If it really returns void, change that to int.  */
			  if (TREE_TYPE (TREE_TYPE (yyval.ttype)) == void_type_node)
			    TREE_TYPE (yyval.ttype)
			      = build_function_type (integer_type_node,
						     TYPE_ARG_TYPES (TREE_TYPE (yyval.ttype)));
			}
		      else
			pedwarn ("built-in function `%s' used without declaration",
				 IDENTIFIER_POINTER (DECL_NAME (yyval.ttype)));

		      /* Do what we would ordinarily do when a fn is used.  */
		      assemble_external (yyval.ttype);
		      TREE_USED (yyval.ttype) = 1;
		    }
		  else
		    {
		      assemble_external (yyval.ttype);
		      TREE_USED (yyval.ttype) = 1;
		    }

		  if (TREE_CODE (yyval.ttype) == CONST_DECL)
		    {
		      yyval.ttype = DECL_INITIAL (yyval.ttype);
		      /* This is to prevent an enum whose value is 0
			 from being considered a null pointer constant.  */
		      yyval.ttype = build1 (NOP_EXPR, TREE_TYPE (yyval.ttype), yyval.ttype);
		      TREE_CONSTANT (yyval.ttype) = 1;
		    }
		}
break;
case 98:
#line 776 "c-parse.y"
{ yyval.ttype = combine_strings (yyvsp[0].ttype); }
break;
case 99:
#line 778 "c-parse.y"
{ char class = TREE_CODE_CLASS (TREE_CODE (yyvsp[-1].ttype));
		  if (class == 'e' || class == '1'
		      || class == '2' || class == '<')
		    C_SET_EXP_ORIGINAL_CODE (yyvsp[-1].ttype, ERROR_MARK);
		  yyval.ttype = yyvsp[-1].ttype; }
break;
case 100:
#line 784 "c-parse.y"
{ yyval.ttype = error_mark_node; }
break;
case 101:
#line 786 "c-parse.y"
{ if (current_function_decl == 0)
		    {
		      error ("braced-group within expression allowed only inside a function");
		      YYERROR;
		    }
		  /* We must force a BLOCK for this level
		     so that, if it is not expanded later,
		     there is a way to turn off the entire subtree of blocks
		     that are contained in it.  */
		  keep_next_level ();
		  push_iterator_stack ();
		  push_label_level ();
		  yyval.ttype = expand_start_stmt_expr (); }
break;
case 102:
#line 800 "c-parse.y"
{ tree rtl_exp;
		  if (pedantic)
		    pedwarn ("ANSI C forbids braced-groups within expressions");
		  pop_iterator_stack ();
		  pop_label_level ();
		  rtl_exp = expand_end_stmt_expr (yyvsp[-2].ttype);
		  /* The statements have side effects, so the group does.  */
		  TREE_SIDE_EFFECTS (rtl_exp) = 1;

		  if (TREE_CODE (yyvsp[-1].ttype) == BLOCK)
		    {
		      /* Make a BIND_EXPR for the BLOCK already made.  */
		      yyval.ttype = build (BIND_EXPR, TREE_TYPE (rtl_exp),
				  NULL_TREE, rtl_exp, yyvsp[-1].ttype);
		      /* Remove the block from the tree at this point.
			 It gets put back at the proper place
			 when the BIND_EXPR is expanded.  */
		      delete_block (yyvsp[-1].ttype);
		    }
		  else
		    yyval.ttype = yyvsp[-1].ttype;
		}
break;
case 103:
#line 823 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = bupc_assert_type(groktypename (yyvsp[-3].ttype), groktypename (yyvsp[-1].ttype)); }
break;
case 104:
#line 826 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = bupc_assert_type(groktypename (yyvsp[-3].ttype), TREE_TYPE(yyvsp[-1].ttype)); }
break;
case 105:
#line 829 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = bupc_assert_type(TREE_TYPE (yyvsp[-3].ttype), groktypename (yyvsp[-1].ttype)); }
break;
case 106:
#line 832 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = bupc_assert_type(TREE_TYPE (yyvsp[-3].ttype), TREE_TYPE(yyvsp[-1].ttype)); }
break;
case 107:
#line 835 "c-parse.y"
{ yyval.ttype = build_function_call (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 108:
#line 837 "c-parse.y"
{ yyval.ttype = build_array_ref (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 109:
#line 839 "c-parse.y"
{
		    yyval.ttype = build_component_ref (yyvsp[-2].ttype, yyvsp[0].ttype);
		}
break;
case 110:
#line 843 "c-parse.y"
{
                  tree expr = build_indirect_ref (yyvsp[-2].ttype, "->");

                    yyval.ttype = build_component_ref (expr, yyvsp[0].ttype);
		}
break;
case 111:
#line 849 "c-parse.y"
{ yyval.ttype = build_unary_op (POSTINCREMENT_EXPR, yyvsp[-1].ttype, 0); }
break;
case 112:
#line 851 "c-parse.y"
{ yyval.ttype = build_unary_op (POSTDECREMENT_EXPR, yyvsp[-1].ttype, 0); }
break;
case 114:
#line 858 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 117:
#line 867 "c-parse.y"
{ c_mark_varargs ();
		  if (pedantic)
		    pedwarn ("ANSI C does not permit use of `varargs.h'"); }
break;
case 118:
#line 877 "c-parse.y"
{ }
break;
case 123:
#line 893 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 124:
#line 898 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);	
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 125:
#line 903 "c-parse.y"
{ shadow_tag_warned (yyvsp[-1].ttype, 1);
		  pedwarn ("empty declaration"); }
break;
case 126:
#line 906 "c-parse.y"
{ pedwarn ("empty declaration"); }
break;
case 127:
#line 936 "c-parse.y"
{ yyval.itype = suspend_momentary ();
		  pending_xref_error ();
		  declspec_stack = tree_cons (prefix_attributes,
					      current_declspecs,
					      declspec_stack);
		  split_specs_attrs (yyvsp[0].ttype,
				     &current_declspecs, &prefix_attributes); }
break;
case 128:
#line 947 "c-parse.y"
{ prefix_attributes = chainon (prefix_attributes, yyvsp[0].ttype); }
break;
case 129:
#line 952 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 130:
#line 957 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 131:
#line 962 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-1].itype); }
break;
case 132:
#line 967 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-1].itype); }
break;
case 133:
#line 972 "c-parse.y"
{ shadow_tag (yyvsp[-1].ttype); }
break;
case 134:
#line 974 "c-parse.y"
{ pedwarn ("empty declaration"); }
break;
case 135:
#line 976 "c-parse.y"
{ pedantic = yyvsp[-1].itype; }
break;
case 136:
#line 986 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 137:
#line 988 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[-2].ttype)); }
break;
case 138:
#line 992 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 139:
#line 994 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 140:
#line 996 "c-parse.y"
{ if (extra_warnings)
		    warning ("`%s' is not at beginning of declaration",
			     IDENTIFIER_POINTER (yyvsp[0].ttype));
		  yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 141:
#line 1001 "c-parse.y"
{ yyval.ttype = tree_cons (yyvsp[0].ttype, NULL_TREE, yyvsp[-1].ttype); }
break;
case 142:
#line 1006 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 143:
#line 1008 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[-2].ttype)); }
break;
case 144:
#line 1013 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 145:
#line 1015 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 146:
#line 1017 "c-parse.y"
{ if (extra_warnings)
		    warning ("`%s' is not at beginning of declaration",
			     IDENTIFIER_POINTER (yyvsp[0].ttype));
		  yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 147:
#line 1030 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 148:
#line 1032 "c-parse.y"
{ yyval.ttype = tree_cons (yyvsp[0].ttype, NULL_TREE, NULL_TREE); }
break;
case 149:
#line 1034 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 150:
#line 1036 "c-parse.y"
{ yyval.ttype = tree_cons (yyvsp[0].ttype, NULL_TREE, yyvsp[-1].ttype); }
break;
case 151:
#line 1041 "c-parse.y"
{ TREE_STATIC (yyval.ttype) = 1; }
break;
case 152:
#line 1043 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, NULL_TREE); }
break;
case 153:
#line 1045 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-1].ttype);
		  TREE_STATIC (yyval.ttype) = 1; }
break;
case 154:
#line 1048 "c-parse.y"
{ if (extra_warnings && TREE_STATIC (yyvsp[-1].ttype))
		    warning ("`%s' is not at beginning of declaration",
			     IDENTIFIER_POINTER (yyvsp[0].ttype));
		  yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype);
		  TREE_STATIC (yyval.ttype) = TREE_STATIC (yyvsp[-1].ttype); }
break;
case 155:
#line 1057 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, NULL_TREE); }
break;
case 156:
#line 1059 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, NULL_TREE); }
break;
case 157:
#line 1061 "c-parse.y"
{ 
	  
		  yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype,
				 tree_cons (NULL_TREE, yyvsp[-1].ttype, NULL_TREE)); }
break;
case 158:
#line 1075 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 159:
#line 1077 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[-2].ttype)); }
break;
case 160:
#line 1083 "c-parse.y"
{ yyval.ttype = tree_cons(NULL_TREE, yyvsp[-1].ttype, NULL_TREE); }
break;
case 161:
#line 1086 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 162:
#line 1088 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 165:
#line 1098 "c-parse.y"
{ /* For a typedef name, record the meaning, not the name.
		     In case of `foo foo, bar;'.  */
		  yyval.ttype = lookup_name (yyvsp[0].ttype); }
break;
case 166:
#line 1102 "c-parse.y"
{ yyval.ttype = TREE_TYPE (yyvsp[-1].ttype); }
break;
case 167:
#line 1104 "c-parse.y"
{ yyval.ttype = groktypename (yyvsp[-1].ttype); }
break;
case 171:
#line 1114 "c-parse.y"
{ 
	  
  yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype,
		  tree_cons (NULL_TREE, yyvsp[-1].ttype, NULL_TREE)); }
break;
case 177:
#line 1133 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 178:
#line 1135 "c-parse.y"
{ if (TREE_CHAIN (yyvsp[-1].ttype)) yyvsp[-1].ttype = combine_strings (yyvsp[-1].ttype);
		  yyval.ttype = yyvsp[-1].ttype;
		}
break;
case 179:
#line 1142 "c-parse.y"
{ yyval.ttype = start_decl (yyvsp[-3].ttype, current_declspecs, 1,
					  yyvsp[-1].ttype, prefix_attributes);
		  start_init (yyval.ttype, yyvsp[-2].ttype, global_bindings_p ()); }
break;
case 180:
#line 1147 "c-parse.y"
{ finish_init ();
		  finish_decl (yyvsp[-1].ttype, yyvsp[0].ttype, yyvsp[-4].ttype); }
break;
case 181:
#line 1150 "c-parse.y"
{ tree d = start_decl (yyvsp[-2].ttype, current_declspecs, 0,
				       yyvsp[0].ttype, prefix_attributes);
		  finish_decl (d, NULL_TREE, yyvsp[-1].ttype); 
                }
break;
case 182:
#line 1158 "c-parse.y"
{ yyval.ttype = start_decl (yyvsp[-3].ttype, current_declspecs, 1,
					  yyvsp[-1].ttype, prefix_attributes);
		  start_init (yyval.ttype, yyvsp[-2].ttype, global_bindings_p ()); }
break;
case 183:
#line 1163 "c-parse.y"
{ finish_init ();
		  decl_attributes (yyvsp[-1].ttype, yyvsp[-3].ttype, prefix_attributes);
		  finish_decl (yyvsp[-1].ttype, yyvsp[0].ttype, yyvsp[-4].ttype); }
break;
case 184:
#line 1167 "c-parse.y"
{ tree d = start_decl (yyvsp[-2].ttype, current_declspecs, 0,
				       yyvsp[0].ttype, prefix_attributes);
		  finish_decl (d, NULL_TREE, yyvsp[-1].ttype); }
break;
case 185:
#line 1175 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 186:
#line 1177 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 187:
#line 1182 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 188:
#line 1184 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 189:
#line 1189 "c-parse.y"
{ yyval.ttype = yyvsp[-2].ttype; }
break;
case 190:
#line 1194 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 191:
#line 1196 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 192:
#line 1201 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 193:
#line 1203 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[0].ttype, NULL_TREE); }
break;
case 194:
#line 1205 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-3].ttype, build_tree_list (NULL_TREE, yyvsp[-1].ttype)); }
break;
case 195:
#line 1207 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-5].ttype, tree_cons (NULL_TREE, yyvsp[-3].ttype, yyvsp[-1].ttype)); }
break;
case 196:
#line 1209 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 203:
#line 1228 "c-parse.y"
{ really_start_incremental_init (NULL_TREE);
		  /* Note that the call to clear_momentary
		     is in process_init_element.  */
		  push_momentary (); }
break;
case 204:
#line 1233 "c-parse.y"
{ yyval.ttype = pop_init_level (0);
		  if (yyval.ttype == error_mark_node
		      && ! (yychar == STRING || yychar == CONSTANT))
		    pop_momentary ();
		  else
		    pop_momentary_nofree (); }
break;
case 205:
#line 1241 "c-parse.y"
{ yyval.ttype = error_mark_node; }
break;
case 206:
#line 1247 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids empty initializer braces"); }
break;
case 212:
#line 1263 "c-parse.y"
{ set_init_label (yyvsp[-1].ttype); }
break;
case 215:
#line 1270 "c-parse.y"
{ push_init_level (0); }
break;
case 216:
#line 1272 "c-parse.y"
{ process_init_element (pop_init_level (0)); }
break;
case 217:
#line 1274 "c-parse.y"
{ process_init_element (yyvsp[0].ttype); }
break;
case 221:
#line 1285 "c-parse.y"
{ set_init_label (yyvsp[0].ttype); }
break;
case 222:
#line 1290 "c-parse.y"
{ set_init_index (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 223:
#line 1292 "c-parse.y"
{ set_init_index (yyvsp[-1].ttype, NULL_TREE); }
break;
case 224:
#line 1297 "c-parse.y"
{ push_function_context ();
		  if (! start_function (current_declspecs, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    {
		      pop_function_context ();
		      YYERROR1;
		    }
		  reinit_parse_for_function (); }
break;
case 225:
#line 1306 "c-parse.y"
{ store_parm_decls (); }
break;
case 226:
#line 1314 "c-parse.y"
{ finish_function (1);
		  pop_function_context (); }
break;
case 227:
#line 1320 "c-parse.y"
{ push_function_context ();
		  if (! start_function (current_declspecs, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    {
		      pop_function_context ();
		      YYERROR1;
		    }
		  reinit_parse_for_function (); }
break;
case 228:
#line 1329 "c-parse.y"
{ store_parm_decls (); }
break;
case 229:
#line 1337 "c-parse.y"
{ finish_function (1);
		  pop_function_context (); }
break;
case 232:
#line 1353 "c-parse.y"
{ yyval.ttype = yyvsp[-1].ttype; }
break;
case 233:
#line 1355 "c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, yyvsp[-2].ttype, yyvsp[0].ttype, NULL_TREE); }
break;
case 234:
#line 1360 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 235:
#line 1362 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-2].ttype, NULL_TREE); }
break;
case 236:
#line 1364 "c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 237:
#line 1371 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 240:
#line 1384 "c-parse.y"
{ if (yyvsp[-1].ttype != ridpointers[(int)RID_STATIC])
	      error ("invalid storage class in array declarator");
	  }
break;
case 241:
#line 1388 "c-parse.y"
{ if (yyvsp[0].ttype != ridpointers[(int)RID_STATIC])
	      error ("invalid storage class in array declarator");
	  }
break;
case 243:
#line 1395 "c-parse.y"
{ }
break;
case 245:
#line 1406 "c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, yyvsp[-2].ttype, yyvsp[0].ttype, NULL_TREE); }
break;
case 246:
#line 1411 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-4].ttype, NULL_TREE);
		  if (! flag_isoc99)
		    error ("`[*]' in parameter declaration only allowed in ISO C 9x");
		}
break;
case 247:
#line 1416 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-4].ttype, yyvsp[-1].ttype); }
break;
case 248:
#line 1418 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, NULL_TREE); }
break;
case 249:
#line 1420 "c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 250:
#line 1427 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 252:
#line 1436 "c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, yyvsp[-2].ttype, yyvsp[0].ttype, NULL_TREE); }
break;
case 253:
#line 1441 "c-parse.y"
{ yyval.ttype = yyvsp[-1].ttype; }
break;
case 254:
#line 1443 "c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 255:
#line 1445 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-4].ttype, NULL_TREE);
		  if (! flag_isoc99)
		    error ("`[*]' in parameter declaration only allowed in ISO C 9x");
		}
break;
case 256:
#line 1450 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-4].ttype, yyvsp[-1].ttype); }
break;
case 257:
#line 1452 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, NULL_TREE); }
break;
case 258:
#line 1459 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 260:
#line 1465 "c-parse.y"
{ yyval.ttype = NULL_TREE; defining_type++; }
break;
case 261:
#line 1467 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; defining_type++; }
break;
case 262:
#line 1472 "c-parse.y"
{ yyval.ttype = NULL_TREE; defining_type++; }
break;
case 263:
#line 1474 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; defining_type++; }
break;
case 264:
#line 1479 "c-parse.y"
{ yyval.ttype = NULL_TREE; defining_type++; }
break;
case 265:
#line 1481 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; defining_type++; }
break;
case 266:
#line 1486 "c-parse.y"
{ yyval.ttype = start_struct (RECORD_TYPE, yyvsp[-1].ttype);
		  /* Start scope of tag before parsing components.  */
		}
break;
case 267:
#line 1490 "c-parse.y"
{ yyval.ttype = finish_struct (yyvsp[-3].ttype, yyvsp[-2].ttype, chainon (yyvsp[-6].ttype, yyvsp[0].ttype));
		  defining_type--;
		}
break;
case 268:
#line 1494 "c-parse.y"
{ yyval.ttype = finish_struct (start_struct (RECORD_TYPE, NULL_TREE),
				      yyvsp[-2].ttype, chainon (yyvsp[-4].ttype, yyvsp[0].ttype));
		  defining_type--;
		}
break;
case 269:
#line 1499 "c-parse.y"
{ yyval.ttype = xref_tag (RECORD_TYPE, yyvsp[0].ttype); defining_type--; }
break;
case 270:
#line 1501 "c-parse.y"
{ yyval.ttype = start_struct (UNION_TYPE, yyvsp[-1].ttype); }
break;
case 271:
#line 1503 "c-parse.y"
{ yyval.ttype = finish_struct (yyvsp[-3].ttype, yyvsp[-2].ttype, chainon (yyvsp[-6].ttype, yyvsp[0].ttype));
		  defining_type--;
		}
break;
case 272:
#line 1507 "c-parse.y"
{ yyval.ttype = finish_struct (start_struct (UNION_TYPE, NULL_TREE),
				      yyvsp[-2].ttype, chainon (yyvsp[-4].ttype, yyvsp[0].ttype));
		  defining_type--;
		}
break;
case 273:
#line 1512 "c-parse.y"
{ yyval.ttype = xref_tag (UNION_TYPE, yyvsp[0].ttype); defining_type--; }
break;
case 274:
#line 1514 "c-parse.y"
{ yyvsp[0].itype = suspend_momentary ();
		  yyval.ttype = start_enum (yyvsp[-1].ttype); }
break;
case 275:
#line 1517 "c-parse.y"
{ yyval.ttype= finish_enum (yyvsp[-4].ttype, nreverse (yyvsp[-3].ttype), chainon (yyvsp[-7].ttype, yyvsp[0].ttype));
		  defining_type--;
		  resume_momentary (yyvsp[-5].itype); }
break;
case 276:
#line 1521 "c-parse.y"
{ yyvsp[0].itype = suspend_momentary ();
		  yyval.ttype = start_enum (NULL_TREE); }
break;
case 277:
#line 1524 "c-parse.y"
{ yyval.ttype= finish_enum (yyvsp[-4].ttype, nreverse (yyvsp[-3].ttype), chainon (yyvsp[-6].ttype, yyvsp[0].ttype));
		  defining_type--;
		  resume_momentary (yyvsp[-5].itype); }
break;
case 278:
#line 1528 "c-parse.y"
{ yyval.ttype = xref_tag (ENUMERAL_TYPE, yyvsp[0].ttype); defining_type--; }
break;
case 282:
#line 1539 "c-parse.y"
{ if (pedantic && ! flag_isoc99)
		    pedwarn ("comma at end of enumerator list"); }
break;
case 283:
#line 1545 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 284:
#line 1547 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-1].ttype, yyvsp[0].ttype);
		  pedwarn ("no semicolon at end of struct or union"); }
break;
case 285:
#line 1552 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 286:
#line 1554 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, yyvsp[-1].ttype); }
break;
case 287:
#line 1556 "c-parse.y"
{ if (pedantic)
		    pedwarn ("extra semicolon in struct or union specified"); }
break;
case 288:
#line 1571 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-1].itype); }
break;
case 289:
#line 1577 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids member declarations with no members");
		  shadow_tag(yyvsp[0].ttype);
		  yyval.ttype = NULL_TREE; }
break;
case 290:
#line 1582 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-1].itype); }
break;
case 291:
#line 1588 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids member declarations with no members");
		  shadow_tag(yyvsp[0].ttype);
		  yyval.ttype = NULL_TREE; }
break;
case 292:
#line 1593 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 293:
#line 1595 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  pedantic = yyvsp[-1].itype; }
break;
case 295:
#line 1602 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 296:
#line 1607 "c-parse.y"
{ yyval.ttype = grokfield (yyvsp[-3].filename, yyvsp[-2].lineno, yyvsp[-1].ttype, current_declspecs, NULL_TREE);
		  decl_attributes (yyval.ttype, yyvsp[0].ttype, prefix_attributes); }
break;
case 297:
#line 1611 "c-parse.y"
{ yyval.ttype = grokfield (yyvsp[-5].filename, yyvsp[-4].lineno, yyvsp[-3].ttype, current_declspecs, yyvsp[-1].ttype);
		  decl_attributes (yyval.ttype, yyvsp[0].ttype, prefix_attributes); }
break;
case 298:
#line 1614 "c-parse.y"
{ yyval.ttype = grokfield (yyvsp[-4].filename, yyvsp[-3].lineno, NULL_TREE, current_declspecs, yyvsp[-1].ttype);
		  decl_attributes (yyval.ttype, yyvsp[0].ttype, prefix_attributes); }
break;
case 300:
#line 1626 "c-parse.y"
{ if (yyvsp[-2].ttype == error_mark_node)
		    yyval.ttype = yyvsp[-2].ttype;
		  else
		    yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-2].ttype); }
break;
case 301:
#line 1631 "c-parse.y"
{ yyval.ttype = error_mark_node; }
break;
case 302:
#line 1637 "c-parse.y"
{ yyval.ttype = build_enumerator (yyvsp[0].ttype, NULL_TREE); }
break;
case 303:
#line 1639 "c-parse.y"
{ yyval.ttype = build_enumerator (yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 304:
#line 1644 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 305:
#line 1646 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 306:
#line 1651 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 309:
#line 1658 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 310:
#line 1663 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 311:
#line 1665 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 312:
#line 1670 "c-parse.y"
{ yyval.ttype = yyvsp[-1].ttype; }
break;
case 313:
#line 1673 "c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 314:
#line 1675 "c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[0].ttype, NULL_TREE); }
break;
case 315:
#line 1677 "c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, yyvsp[-2].ttype, yyvsp[0].ttype, NULL_TREE); }
break;
case 316:
#line 1679 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-4].ttype, yyvsp[-1].ttype); }
break;
case 317:
#line 1681 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, NULL_TREE); }
break;
case 318:
#line 1683 "c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, NULL_TREE, yyvsp[0].ttype, NULL_TREE); }
break;
case 319:
#line 1685 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, NULL_TREE, yyvsp[-1].ttype); }
break;
case 320:
#line 1687 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, NULL_TREE, NULL_TREE); }
break;
case 321:
#line 1691 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 322:
#line 1700 "c-parse.y"
{
		  if (pedantic && yyvsp[0].ends_in_label)
		    pedwarn ("ANSI C forbids label at end of compound statement");
		}
break;
case 324:
#line 1709 "c-parse.y"
{ yyval.ends_in_label = yyvsp[0].ends_in_label; }
break;
case 325:
#line 1711 "c-parse.y"
{ yyval.ends_in_label = 0; }
break;
case 327:
#line 1724 "c-parse.y"
{ emit_line_note (input_filename, lineno);
		  pushlevel (0);
		  clear_last_expr ();
		  push_momentary ();
		  UPC_statement_pragma_ok = 0;
		  expand_start_bindings (0);
		}
break;
case 329:
#line 1738 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids label declarations"); }
break;
case 332:
#line 1749 "c-parse.y"
{ tree link;
		  for (link = yyvsp[-1].ttype; link; link = TREE_CHAIN (link))
		    {
		      tree label = shadow_label (TREE_VALUE (link));
		      C_DECLARED_LABEL_FLAG (label) = 1;
		      declare_nonlocal_label (label);
		    }
		}
break;
case 333:
#line 1763 "c-parse.y"
{}
break;
case 335:
#line 1767 "c-parse.y"
{ 
	  push_consistency_nesting_level (1);
	  UPC_statement_pragma_ok = 1;
	  compstmt_count++; }
break;
case 336:
#line 1773 "c-parse.y"
{ yyval.ttype = convert (void_type_node, integer_zero_node);
		pop_consistency_nesting_level (1);	}
break;
case 337:
#line 1777 "c-parse.y"
{ emit_line_note (input_filename, lineno);
		  expand_end_bindings (getdecls (), kept_level_p (), 0);
		  yyval.ttype = poplevel (kept_level_p (), 0, 0);
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary ();
		  pop_consistency_nesting_level (1); }
break;
case 338:
#line 1786 "c-parse.y"
{ emit_line_note (input_filename, lineno);
		  expand_end_bindings (getdecls (), kept_level_p (), 0);
		  yyval.ttype = poplevel (kept_level_p (), 0, 0);
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary (); 
		  pop_consistency_nesting_level (1);	}
break;
case 341:
#line 1807 "c-parse.y"
{ emit_line_note (yyvsp[-5].filename, yyvsp[-4].lineno);
		  c_expand_start_cond (truthvalue_conversion (yyvsp[-1].ttype), 0, 
				       compstmt_count);
		  yyval.itype = stmt_count;
		  if_stmt_file = yyvsp[-5].filename;
		  if_stmt_line = yyvsp[-4].lineno;
		  position_after_white_space (); }
break;
case 342:
#line 1821 "c-parse.y"
{ stmt_count++;
		  compstmt_count++;
		  emit_line_note (yyvsp[-2].filename, yyvsp[-1].lineno);
		  /* See comment in `while' alternative, above.  */
		  emit_nop ();
		  expand_start_loop_continue_elsewhere (1);
		  position_after_white_space (); }
break;
case 343:
#line 1829 "c-parse.y"
{ expand_loop_continue_here (); }
break;
case 344:
#line 1833 "c-parse.y"
{ yyval.filename = input_filename; }
break;
case 345:
#line 1837 "c-parse.y"
{ yyval.lineno = lineno; }
break;
case 346:
#line 1842 "c-parse.y"
{ }
break;
case 347:
#line 1847 "c-parse.y"
{ }
break;
case 348:
#line 1852 "c-parse.y"
{ yyval.ends_in_label = yyvsp[0].ends_in_label; }
break;
case 349:
#line 1857 "c-parse.y"
{ yyval.ends_in_label = 0; }
break;
case 350:
#line 1859 "c-parse.y"
{ yyval.ends_in_label = 1; }
break;
case 351:
#line 1861 "c-parse.y"
{ yyval.ends_in_label = 0; }
break;
case 352:
#line 1868 "c-parse.y"
{ stmt_count++; }
break;
case 354:
#line 1871 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
/* It appears that this should not be done--that a non-lvalue array
   shouldn't get an error if the value isn't used.
   Section 3.2.2.1 says that an array lvalue gets converted to a pointer
   if it appears as a top-level expression,
   but says nothing about non-lvalue arrays.  */
#if 0
		  /* Call default_conversion to get an error
		     on referring to a register array if pedantic.  */
		  if (TREE_CODE (TREE_TYPE (yyvsp[-1].ttype)) == ARRAY_TYPE
		      || TREE_CODE (TREE_TYPE (yyvsp[-1].ttype)) == FUNCTION_TYPE)
		    yyvsp[-1].ttype = default_conversion (yyvsp[-1].ttype);
#endif
		  iterator_expand (yyvsp[-1].ttype);
		  clear_momentary (); }
break;
case 355:
#line 1888 "c-parse.y"
{ c_expand_start_else ();
		  yyvsp[-1].itype = stmt_count;
		  position_after_white_space (); }
break;
case 356:
#line 1892 "c-parse.y"
{ c_expand_end_cond ();
		  if (extra_warnings && stmt_count == yyvsp[-3].itype)
		    warning ("empty body in an else-statement"); }
break;
case 357:
#line 1896 "c-parse.y"
{ c_expand_end_cond ();
		  /* This warning is here instead of in simple_if, because we
		     do not want a warning if an empty if is followed by an
		     else statement.  Increment stmt_count so we don't
		     give a second error if this is a nested `if'.  */
		  if (extra_warnings && stmt_count++ == yyvsp[0].itype)
		    warning_with_file_and_line (if_stmt_file, if_stmt_line,
						"empty body in an if-statement"); }
break;
case 358:
#line 1908 "c-parse.y"
{ c_expand_end_cond (); }
break;
case 359:
#line 1910 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-2].filename, yyvsp[-1].lineno);
		  /* The emit_nop used to come before emit_line_note,
		     but that made the nop seem like part of the preceding line.
		     And that was confusing when the preceding line was
		     inside of an if statement and was not really executed.
		     I think it ought to work to put the nop after the line number.
		     We will see.  --rms, July 15, 1991.  */
		  emit_nop (); }
break;
case 360:
#line 1920 "c-parse.y"
{ /* Don't start the loop till we have succeeded
		     in parsing the end test.  This is to make sure
		     that we end every loop we start.  */
		  expand_start_loop (1);
		  emit_line_note (input_filename, lineno);
		  expand_exit_loop_if_false (NULL_PTR,
					     truthvalue_conversion (yyvsp[-1].ttype));
		  position_after_white_space (); }
break;
case 361:
#line 1929 "c-parse.y"
{ expand_end_loop (); }
break;
case 362:
#line 1932 "c-parse.y"
{ emit_line_note (input_filename, lineno);
		  expand_exit_loop_if_false (NULL_PTR,
					     truthvalue_conversion (yyvsp[-2].ttype));
		  expand_end_loop ();
		  clear_momentary (); }
break;
case 363:
#line 1939 "c-parse.y"
{ expand_end_loop ();
		  clear_momentary (); }
break;
case 364:
#line 1941 "c-parse.y"
{ stmt_count++;
		  WFE_Pop_Pragma(); /* see comments in wfe_dst.cxx*/
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  /* See comment in `while' alternative, above.  */
		  emit_nop ();
		  if (yyvsp[0].ttype && yyvsp[0].ttype != c99_for_node)
		    c_expand_expr_stmt (yyvsp[0].ttype);
		  WFE_Push_Pragma();

		  /* Next step is to call expand_start_loop_continue_elsewhere,
		     but wait till after we parse the entire for (...).
		     Otherwise, invalid input might cause us to call that
		     fn without calling expand_end_loop.  */
		}
break;
case 365:
#line 1957 "c-parse.y"
{
		  yyvsp[0].lineno = lineno;
		  yyval.filename = input_filename; 
		}
break;
case 366:
#line 1962 "c-parse.y"
{ 
		  /* Start the loop.  Doing this after parsing
		     all the expressions ensures we will end the loop.  */
		  expand_start_loop_continue_elsewhere (1);
		  /* Emit the end-test, with a line number.  */
		  /* emit_line_note ($<filename>8, $<lineno>7); */
		  emit_line_note (yyvsp[-2].filename, yyvsp[-3].lineno);
		  if (yyvsp[-4].ttype) 
		    expand_exit_loop_if_false (NULL_PTR,
					       truthvalue_conversion (yyvsp[-4].ttype)); 
					       
		  /* Don't let the tree nodes for $9 be discarded by
		     clear_momentary during the parsing of the next stmt.  */
		  push_momentary ();
		  yyvsp[-3].lineno = lineno;
		  yyvsp[-2].filename = input_filename;
		  position_after_white_space (); }
break;
case 367:
#line 1980 "c-parse.y"
{ /* Emit the increment expression, with a line number.  */
		  emit_line_note (yyvsp[-4].filename, yyvsp[-5].lineno);
		  expand_loop_continue_here ();
		   if (yyvsp[-3].ttype) 
 		    c_expand_expr_stmt (yyvsp[-3].ttype); 
		 
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary ();
		  if (yyvsp[-8].ttype == c99_for_node)
		    poplevel(1,0,0);
		  expand_end_loop ();
		  if (yyvsp[-8].ttype == c99_for_node)
		    WFE_Finish_Inner_Scope();
		}
break;
case 368:
#line 1998 "c-parse.y"
{ stmt_count++;
		  WFE_Pop_Pragma();
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  /* See comment in `while' alternative, above.  */
		  emit_nop ();
		  if (yyvsp[0].ttype && yyvsp[0].ttype != c99_for_node)
		    c_expand_expr_stmt (yyvsp[0].ttype);
		  WFE_Push_Pragma();
		  /* Next step is to call expand_start_loop_continue_elsewhere,
		     but wait till after we parse the entire for (...).
		     Otherwise, invalid input might cause us to call that
		     fn without calling expand_end_loop.  */
		}
break;
case 369:
#line 2013 "c-parse.y"
{ yyvsp[0].lineno = lineno;
		  yyval.filename = input_filename; }
break;
case 370:
#line 2016 "c-parse.y"
{ 
		/* Can't emit now; wait till after expand_start_loop...  */
		  /* $<lineno>10 = lineno; */
		  yyvsp[0].lineno = lineno;
		  yyval.filename = input_filename; }
break;
case 371:
#line 2022 "c-parse.y"
{
		  /* The xexpr of $11 is the affinity expression that
		     determines which thread executes a given iteration
		     of the FORALL loop.  It can evaluate either to a
		     shared address with a thread component or to an
		     integer in the range 0-(THREADS-1), inclusive.  The
		     thread component or the integer will specify the
		     executing thread. */
		  /* In the current implementation the FORALL loop body
		     will be wrapped inside a runtime conditional.  In
		     an unoptimized version, each thread will execute every
		     loop iteration of the loop, deciding on each iteration
		     whether to execute the body or to do the equivalent
		     of "continue" if the affinity is wrong. */
		  /* Start the loop.  Doing this after parsing
		     all the expressions ensures we will end the loop.  */
		  expand_start_loop_continue_elsewhere (1);
		  
		    /* Emit the affinity-test, with a line number.  */
		  emit_line_note (yyvsp[-2].filename, yyvsp[-3].lineno);
		  if (yyvsp[-1].ttype)
		    expand_affinity_test (yyvsp[-1].ttype);

		  /* Emit the end-test, with a line number.  */
		  emit_line_note (yyvsp[-2].filename, yyvsp[-3].lineno);
		  if (yyvsp[-7].ttype)
		    expand_exit_loop_if_false (NULL_PTR,
					       truthvalue_conversion (yyvsp[-7].ttype));
		
		  /* Don't let the tree nodes for $9 be discarded by
		     clear_momentary during the parsing of the next stmt.  */
		  push_momentary ();
		  yyvsp[-3].lineno = lineno;
		  yyvsp[-2].filename = input_filename;
		  position_after_white_space (); }
break;
case 372:
#line 2058 "c-parse.y"
{ /* Emit the increment expression, with a line number.  */
		  emit_line_note (yyvsp[-4].filename, yyvsp[-5].lineno);
		  expand_loop_continue_here ();
		  if (yyvsp[-6].ttype)
		    c_expand_expr_stmt (yyvsp[-6].ttype);
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary ();
		  if (yyvsp[-11].ttype == c99_for_node)
		    poplevel(1,0,0);
		  expand_end_loop ();
		  if (yyvsp[-11].ttype == c99_for_node)
		    WFE_Finish_Inner_Scope();
		}
break;
case 373:
#line 2074 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-5].filename, yyvsp[-4].lineno);
		  c_expand_start_case (yyvsp[-1].ttype);
		  /* Don't let the tree nodes for $3 be discarded by
		     clear_momentary during the parsing of the next stmt.  */
		  push_momentary ();
		  position_after_white_space (); }
break;
case 374:
#line 2082 "c-parse.y"
{ expand_end_case (yyvsp[-3].ttype);
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary (); }
break;
case 375:
#line 2088 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  if ( ! expand_exit_something ())
		    error ("break statement not within loop or switch"); }
break;
case 376:
#line 2093 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  if (! expand_continue_loop (NULL_PTR))
		    error ("continue statement not within a loop"); }
break;
case 377:
#line 2098 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  c_expand_return (NULL_TREE); }
break;
case 378:
#line 2102 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  c_expand_return (yyvsp[-1].ttype); }
break;
case 379:
#line 2106 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  upc_expand_sync (1, NULL_TREE); }
break;
case 380:
#line 2110 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  upc_expand_sync (4, NULL_TREE); }
break;
case 381:
#line 2114 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  upc_expand_sync (1, yyvsp[-1].ttype); }
break;
case 382:
#line 2118 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  upc_expand_sync (2, NULL_TREE); }
break;
case 383:
#line 2122 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  upc_expand_sync (2, yyvsp[-1].ttype); }
break;
case 384:
#line 2126 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  upc_expand_sync (3, NULL_TREE); }
break;
case 385:
#line 2130 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  upc_expand_sync (3, yyvsp[-1].ttype); }
break;
case 386:
#line 2134 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-7].filename, yyvsp[-6].lineno);
		  STRIP_NOPS (yyvsp[-2].ttype);
		  if ((TREE_CODE (yyvsp[-2].ttype) == ADDR_EXPR
		       && TREE_CODE (TREE_OPERAND (yyvsp[-2].ttype, 0)) == STRING_CST)
		      || TREE_CODE (yyvsp[-2].ttype) == STRING_CST)
		    expand_asm (yyvsp[-2].ttype);
		  else
		    error ("argument of `asm' is not a constant string"); }
break;
case 387:
#line 2145 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-9].filename, yyvsp[-8].lineno);
		  c_expand_asm_operands (yyvsp[-4].ttype, yyvsp[-2].ttype, NULL_TREE, NULL_TREE,
					 yyvsp[-6].ttype == ridpointers[(int)RID_VOLATILE],
					 input_filename, lineno); }
break;
case 388:
#line 2152 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-11].filename, yyvsp[-10].lineno);
		  c_expand_asm_operands (yyvsp[-6].ttype, yyvsp[-4].ttype, yyvsp[-2].ttype, NULL_TREE,
					 yyvsp[-8].ttype == ridpointers[(int)RID_VOLATILE],
					 input_filename, lineno); }
break;
case 389:
#line 2160 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-13].filename, yyvsp[-12].lineno);
		  c_expand_asm_operands (yyvsp[-8].ttype, yyvsp[-6].ttype, yyvsp[-4].ttype, yyvsp[-2].ttype,
					 yyvsp[-10].ttype == ridpointers[(int)RID_VOLATILE],
					 input_filename, lineno); }
break;
case 390:
#line 2166 "c-parse.y"
{ tree decl;
		  stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  decl = lookup_label (yyvsp[-1].ttype);
		  if (decl != 0)
		    {
		      TREE_USED (decl) = 1;
		      expand_goto (decl);
		    }
		}
break;
case 391:
#line 2177 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids `goto *expr;'");
		  stmt_count++;
		  emit_line_note (yyvsp[-5].filename, yyvsp[-4].lineno);
		  expand_computed_goto (convert (ptr_type_node, yyvsp[-1].ttype)); }
break;
case 393:
#line 2186 "c-parse.y"
{
	  pushlevel (0);  /* Add a new level for the declarations in a for loop header */
	  WFE_Start_Inner_Scope();
	}
break;
case 394:
#line 2194 "c-parse.y"
{ yyval.ttype = yyvsp[-1].ttype;}
break;
case 395:
#line 2196 "c-parse.y"
{ 
	      check_for_loop_decls(); 
	      yyval.ttype = c99_for_node;
	    }
break;
case 397:
#line 2205 "c-parse.y"
{yyval.ttype = NULL_TREE;}
break;
case 399:
#line 2215 "c-parse.y"
{
	    /* The value returned by this action is  */
	    /*      1 if everything is OK */ 
	    /*      0 in case of error or already bound iterator */

	    yyval.itype = 0;
	    if (TREE_CODE (yyvsp[-1].ttype) != VAR_DECL)
	      error ("invalid `for (ITERATOR)' syntax");
	    else if (! ITERATOR_P (yyvsp[-1].ttype))
	      error ("`%s' is not an iterator",
		     IDENTIFIER_POINTER (DECL_NAME (yyvsp[-1].ttype)));
	    else if (ITERATOR_BOUND_P (yyvsp[-1].ttype))
	      error ("`for (%s)' inside expansion of same iterator",
		     IDENTIFIER_POINTER (DECL_NAME (yyvsp[-1].ttype)));
	    else
	      {
		yyval.itype = 1;
		iterator_for_loop_start (yyvsp[-1].ttype);
	      }
	  }
break;
case 400:
#line 2236 "c-parse.y"
{
	    if (yyvsp[-1].itype)
	      iterator_for_loop_end (yyvsp[-3].ttype);
	  }
break;
case 401:
#line 2271 "c-parse.y"
{ register tree value = check_case_value (yyvsp[-1].ttype);
		  register tree label
		    = build_decl (LABEL_DECL, NULL_TREE, NULL_TREE);

		  stmt_count++;

		  if (value != error_mark_node)
		    {
		      tree duplicate;
		      int success;

		      if (pedantic && ! INTEGRAL_TYPE_P (TREE_TYPE (value)))
			pedwarn ("label must have integral type in ANSI C");

		      success = pushcase (value, convert_and_check,
					  label, &duplicate);

		      if (success == 1)
			error ("case label not within a switch statement");
		      else if (success == 2)
			{
			  error ("duplicate case value");
			  error_with_decl (duplicate, "this is the first entry for that value");
			}
		      else if (success == 3)
			warning ("case value out of range");
		      else if (success == 5)
			error ("case label within scope of cleanup or variable array");
		    }
		  position_after_white_space (); }
break;
case 402:
#line 2302 "c-parse.y"
{ register tree value1 = check_case_value (yyvsp[-3].ttype);
		  register tree value2 = check_case_value (yyvsp[-1].ttype);
		  register tree label
		    = build_decl (LABEL_DECL, NULL_TREE, NULL_TREE);

		  if (pedantic)
		    pedwarn ("ANSI C forbids case ranges");
		  stmt_count++;

		  if (value1 != error_mark_node && value2 != error_mark_node)
		    {
		      tree duplicate;
		      int success = pushcase_range (value1, value2,
						    convert_and_check, label,
						    &duplicate);
		      if (success == 1)
			error ("case label not within a switch statement");
		      else if (success == 2)
			{
			  error ("duplicate case value");
			  error_with_decl (duplicate, "this is the first entry for that value");
			}
		      else if (success == 3)
			warning ("case value out of range");
		      else if (success == 4)
			warning ("empty case range");
		      else if (success == 5)
			error ("case label within scope of cleanup or variable array");
		    }
		  position_after_white_space (); }
break;
case 403:
#line 2333 "c-parse.y"
{
		  tree duplicate;
		  register tree label
		    = build_decl (LABEL_DECL, NULL_TREE, NULL_TREE);
		  int success = pushcase (NULL_TREE, 0, label, &duplicate);
		  stmt_count++;
		  if (success == 1)
		    error ("default label not within a switch statement");
		  else if (success == 2)
		    {
		      error ("multiple default labels in one switch");
		      error_with_decl (duplicate, "this is the first default label");
		    }
		  position_after_white_space (); }
break;
case 404:
#line 2348 "c-parse.y"
{ tree label = define_label (input_filename, lineno, yyvsp[-2].ttype);
		  stmt_count++;
		  emit_nop ();
		  if (label)
		    {
		      expand_label (label);
		      decl_attributes (label, yyvsp[0].ttype, NULL_TREE);
		    }
		  position_after_white_space (); }
break;
case 405:
#line 2363 "c-parse.y"
{ emit_line_note (input_filename, lineno);
		  yyval.ttype = NULL_TREE; }
break;
case 406:
#line 2366 "c-parse.y"
{ emit_line_note (input_filename, lineno); }
break;
case 407:
#line 2371 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 409:
#line 2375 "c-parse.y"
{ yyval.ttype = star_layout_node; }
break;
case 410:
#line 2381 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 413:
#line 2388 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 414:
#line 2393 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 415:
#line 2398 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, combine_strings (yyvsp[0].ttype), NULL_TREE); }
break;
case 416:
#line 2400 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, combine_strings (yyvsp[0].ttype), yyvsp[-2].ttype); }
break;
case 417:
#line 2406 "c-parse.y"
{ pushlevel (0);
		  clear_parm_order ();
		  declare_parm_level (0); }
break;
case 418:
#line 2410 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  parmlist_tags_warning ();
		  poplevel (0, 0, 0); }
break;
case 420:
#line 2418 "c-parse.y"
{ tree parm;
		  if (pedantic)
		    pedwarn ("ANSI C forbids forward parameter declarations");
		  /* Mark the forward decls as such.  */
		  for (parm = getdecls (); parm; parm = TREE_CHAIN (parm))
		    TREE_ASM_WRITTEN (parm) = 1;
		  clear_parm_order (); }
break;
case 421:
#line 2426 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 422:
#line 2428 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, NULL_TREE, NULL_TREE); }
break;
case 423:
#line 2434 "c-parse.y"
{ yyval.ttype = get_parm_info (0); }
break;
case 424:
#line 2436 "c-parse.y"
{ yyval.ttype = get_parm_info (0);
		  /* Gcc used to allow this as an extension.  However, it does
		     not work for all targets, and thus has been disabled.
		     Also, since func (...) and func () are indistinguishable,
		     it caused problems with the code in expand_builtin which
		     tries to verify that BUILT_IN_NEXT_ARG is being used
		     correctly.  */
		  error ("ANSI C requires a named argument before `...'");
		}
break;
case 425:
#line 2446 "c-parse.y"
{ yyval.ttype = get_parm_info (1); }
break;
case 426:
#line 2448 "c-parse.y"
{ yyval.ttype = get_parm_info (0); }
break;
case 427:
#line 2453 "c-parse.y"
{ push_parm_decl (yyvsp[0].ttype); }
break;
case 428:
#line 2455 "c-parse.y"
{ push_parm_decl (yyvsp[0].ttype); }
break;
case 429:
#line 2462 "c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype));
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 430:
#line 2471 "c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype)); 
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 431:
#line 2480 "c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype));
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 432:
#line 2489 "c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype));
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype);  }
break;
case 433:
#line 2499 "c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype));
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype);  }
break;
case 434:
#line 2513 "c-parse.y"
{ pushlevel (0);
		  clear_parm_order ();
		  declare_parm_level (1); }
break;
case 435:
#line 2517 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  parmlist_tags_warning ();
		  poplevel (0, 0, 0); }
break;
case 437:
#line 2525 "c-parse.y"
{ tree t;
		  for (t = yyvsp[-1].ttype; t; t = TREE_CHAIN (t))
		    if (TREE_VALUE (t) == NULL_TREE)
		      error ("`...' in old-style identifier list");
		  yyval.ttype = tree_cons (NULL_TREE, NULL_TREE, yyvsp[-1].ttype); }
break;
case 438:
#line 2535 "c-parse.y"
{ yyval.ttype = build_tree_list (NULL_TREE, yyvsp[0].ttype); }
break;
case 439:
#line 2537 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, build_tree_list (NULL_TREE, yyvsp[0].ttype)); }
break;
case 440:
#line 2543 "c-parse.y"
{ yyval.ttype = build_tree_list (NULL_TREE, yyvsp[0].ttype); }
break;
case 441:
#line 2545 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, build_tree_list (NULL_TREE, yyvsp[0].ttype)); }
break;
case 442:
#line 2550 "c-parse.y"
{ yyval.itype = pedantic;
		  pedantic = 0; }
break;
#line 4669 "c-parse.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
